# Gamma.jl
[![Build Status](https://github.com/JuliaMath/Gamma.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/JuliaMath/Gamma.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/JuliaMath/Gamma.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaMath/Gamma.jl)

Simple and fast Gamma function.

This library provides a dependence-free, Julia native implementation of the [Gamma function](https://en.wikipedia.org/wiki/Gamma_function) and related utilities like `loggamma`, `logabsgamma` and `digamma`.

Supports `Integer`, `Float16`, `Float32`, and `Float64`, `Complex` and `BigFloat` arguments.

## Contributing

Contributions are very welcome, as are feature requests, suggestions or general discussions.
Please open an issue for discussion on newer implementations, share papers, new features, or if you encounter any problems.
Our goal is to provide high quality Julia native implementations of Gamma functions that match or exceed the accuracy of the implementations provided by SpecialFunctions.jl.
Please let us know if you encounter any accuracy or performance issues.

# Pure Julia loggamma and logabsgamma implementations
# Partly adapted from SpecialFunctions.jl (MIT license)
# using Stirling asymptotic series, Taylor series at z=1 and z=2,
# reflection formula, and shift recurrence.
# See: D. E. G. Hare, "Computing the principal branch of log-Gamma,"
# J. Algorithms 25, pp. 221-236 (1997)

####################################
## Typed getters returning literals
####################################

# Stirling coefficients
function _stirling_coeffs(::Type{Float64})
    return (
        8.333333333333333333333368e-02, -2.777777777777777777777778e-03,
        7.936507936507936507936508e-04, -5.952380952380952380952381e-04,
        8.417508417508417508417510e-04, -1.917526917526917526917527e-03,
        6.410256410256410256410257e-03, -2.955065359477124183006535e-02
    )
end
function _stirling_coeffs(::Type{Float32})
    return (
        0.083333336f0, -0.0027777778f0, 0.0007936508f0,
        -0.0005952381f0, 0.0008417508f0
    )
end

# Remez approximation of stirling series
# on real range (7, Inf)
# generated with the following code
#=
using Remez
# 23 length stirling approximation as reference
nums = (1, -1, 1, -1, 1, -691, 1, -3617, 43867, -174611, 77683, -236364091, 657931, -3392780147, 1723168255201, -7709321041217, 151628697551, -26315271553053477373, 154210205991661, -261082718496449122051, 1520097643918070802691, -2530297234481911294093, 25932657025822267968607)
dens = (12, 360, 1260, 1680, 1188, 360360, 156, 122400, 244188, 125400, 5796, 1506960, 300, 93960, 2492028, 505920, 396, 2418179400, 444, 21106800, 3109932, 118680, 25380)
f(x) = evalpoly(x, nums .// dens)
# bounds are (0.0, 1/big(49)) because this polynomial is evaluated on 1/x^2 where x in (7,inf)
Float64.(Tuple(ratfn_minimax(f, (0.0, 1/big(49)), 5, 0)[1]))
Float32.(Tuple(ratfn_minimax(f, (0.0, 1/big(49)), 2, 0)[1]))
=#
function _real_stirling_coeffs(::Type{Float64})
    return (
        0.08333333333333316, -0.002777777777178877, 0.0007936504460165119,
        -0.0005951639750962075, 0.0008345327674207549, -0.001584519557112229
    )
end
function _real_stirling_coeffs(::Type{Float32})
    return (0.083333336f0, -0.0027776447f0, 0.0007760338f0)
end

# Taylor series around 1 and 2
function _taylor1(::Type{Float64})
    return (
        -5.7721566490153286060651188e-01, 8.2246703342411321823620794e-01,
        -4.0068563438653142846657956e-01, 2.705808084277845478790009e-01,
        -2.0738555102867398526627303e-01, 1.6955717699740818995241986e-01,
        -1.4404989676884611811997107e-01, 1.2550966952474304242233559e-01,
        -1.1133426586956469049087244e-01, 1.000994575127818085337147e-01,
        -9.0954017145829042232609344e-02, 8.3353840546109004024886499e-02,
        -7.6932516411352191472827157e-02, 7.1432946295361336059232779e-02,
        -6.6668705882420468032903454e-02
    )
end
function _taylor1(::Type{Float32})
    return (
        -0.5772157f0, 0.822467f0, -0.40068564f0, 0.2705808f0,
        -0.20738555f0, 0.16955718f0, -0.1440499f0, 0.12550966f0,
        -0.111334264f0, 0.10009946f0
    )
end

function _taylor2(::Type{Float64})
    return (
        4.2278433509846713939348812e-01, 3.2246703342411321823620794e-01,
        -6.7352301053198095133246196e-02, 2.0580808427784547879000897e-02,
        -7.3855510286739852662729527e-03, 2.8905103307415232857531201e-03,
        -1.1927539117032609771139825e-03, 5.0966952474304242233558822e-04,
        -2.2315475845357937976132853e-04, 9.9457512781808533714662972e-05,
        -4.4926236738133141700224489e-05, 2.0507212775670691553131246e-05
    )
end
function _taylor2(::Type{Float32})
    return (
        0.42278433f0, 0.32246703f0, -0.0673523f0, 0.020580808f0,
        -0.007385551f0, 0.0028905103f0, -0.0011927539f0, 0.00050966954f0
    )
end

# Typed constant getters
_half_log2pi(::Type{Float64}) = 0.9189385332046728
_half_log2pi(::Type{Float32}) = 0.9189385f0

_logpi(::Type{Float64}) = 1.1447298858494002
_logpi(::Type{Float32}) = 1.1447299f0

# Generic loggamma entry points
loggamma(x::Union{Float32, Float64}) = _loggamma(x)
loggamma(x::Float16) = Float16(_loggamma(Float32(x)))
loggamma(x::Union{Integer, Rational}) = loggamma(float(x))
loggamma(z::Complex{<:Union{Float32, Float64}}) = _loggamma(z)
loggamma(z::Complex{Float16}) = Complex{Float16}(_loggamma(Complex{Float32}(z)))
function loggamma(z::Complex{<:Union{Integer, Rational}})
    zf = Complex(float.(reim(z))...)
    return _loggamma(zf)
end
function loggamma(x::BigFloat)
    # For now we use the same implementation for BigFloat as Complex{BigFloat}. This is not ideal since it does more work than necessary.
    if isnan(x)
        return x
    elseif isinf(x)
        return x > 0 ? x : BigFloat(NaN)
    elseif x <= 0
        iszero(x) && return BigFloat(Inf)
        isinteger(x) && return BigFloat(Inf)  # negative integer pole
        y, sgn = _logabsgamma(x)
        sgn < 0 && throw(DomainError(x, "`gamma(x)` must be non-negative"))
        return y
    end
    return real(_loggamma_complex_bigfloat(Complex{BigFloat}(x, zero(BigFloat))))
end
loggamma(z::Complex{BigFloat}) = _loggamma(z)

"""
    logfactorial(x)

Compute the logarithmic factorial of a nonnegative integer `x` via loggamma.
"""
function logfactorial(x::Integer)
    if x < 0
        throw(DomainError(x, "`x` must be non-negative."))
    end
    return loggamma(float(x + oneunit(x)))
end

####################################
## Float64 / Float32 loggamma and logabsgamma implementations
####################################

"""
    logabsgamma(x::Real)

Returns a tuple `(log(abs(Γ(x))), sign(Γ(x)))` for real `x`.
"""
logabsgamma(x::Float32) = _logabsgamma(x)
logabsgamma(x::Real) = _logabsgamma(float(x))
function logabsgamma(x::Float16)
    y, s = _logabsgamma(Float32(x))
    return Float16(y), s
end

function _loggamma_stirling_real(x)
    T = typeof(real(x))
    tinv = inv(x)
    w = tinv * tinv
    tail = tinv * evalpoly(w, _real_stirling_coeffs(T))
    return muladd(x - one(T)/2, log(x), _half_log2pi(T) - x + tail)
end

# Generic unsafe-positive loggamma
function _loggamma_unsafe_pos(x::T) where T<:Union{Float32,Float64}
    # Use Taylor expansions near x=1 and x=2
    if abs(x - 1) < 0.1
        w = x - one(T)
        return w * evalpoly(w, _taylor1(T))
    elseif abs(x - 2) < 0.1
        w = x - 2
        return w * evalpoly(w, _taylor2(T))
    elseif x < 7
        n = 7 - floor(Int, x)
        z = x
        prod = one(x)
        for i in 0:n-1
            prod *= z + i
        end
        return _loggamma_stirling_real(z + n) - log(prod)
    else
        return _loggamma_stirling_real(x)
    end
end

# logabsgamma without safety checks (used to avoid double checks)
function _logabsgamma_unsafe_sub0(x::T) where T<:Union{Float32,Float64}
    s = sinpi(x)
    sgn = signbit(s) ? -1 : 1
    return _logpi(T) - log(abs(s)) - _loggamma_unsafe_pos(T(1) - x), sgn
end

function _logabsgamma(x::T) where T<:Union{Float32,Float64}
    if isnan(x)
        return x, 1
    elseif x > zero(x)
        return _loggamma_unsafe_pos(x), 1
    elseif iszero(x)
        return T(Inf), Int(sign(1 / x))
    else
        s = sinpi(x)
        iszero(s) && return T(Inf), 1
        sgn = signbit(s) ? -1 : 1
        return _logpi(T) - log(abs(s)) - _loggamma_unsafe_pos(T(1) - x), sgn
    end
end

"""
    loggamma(x::Real)

Returns the log of the absolute value of ``\\Gamma(x)`` for real `x`.
Throws a `DomainError` if ``\\Gamma(x)`` is negative.

For complex arguments, `exp(loggamma(x))` matches `gamma(x)` up to floating-point error
but may differ from `log(gamma(x))` by an integer multiple of ``2\\pi i``.

External links: [DLMF](https://dlmf.nist.gov/5.4), [Wikipedia](https://en.wikipedia.org/wiki/Gamma_function#The_log-gamma_function)
"""
function _loggamma(x::T) where T<:Union{Float32,Float64}
    if isnan(x)
        return x
    elseif isinf(x)
        return (x > 0 ? T(Inf) : T(NaN))
    elseif x ≤ 0
        if iszero(x)
            return T(Inf)
        elseif isinteger(x)
            return T(Inf)
        else
            y, sgn = _logabsgamma_unsafe_sub0(x)
            sgn < 0 && throw(DomainError(x, "`gamma(x)` must be non-negative"))
            return y
        end
    end
    return _loggamma_unsafe_pos(x)
end

####################################
## Complex{Float64} / Complex{Float32} loggamma implementation
####################################

function _loggamma_stirling(x)
    T = typeof(real(x))
    tinv = inv(x)
    w = tinv * tinv
    tail = tinv * evalpoly(w, _stirling_coeffs(T))
    return muladd(x - one(T)/2, log(x), -x + _half_log2pi(T) + tail)
end

function _loggamma(z::Complex{T}) where T<:Union{Float32,Float64}
    x, y = reim(z)
    yabs = abs(y)

    if !isfinite(x) || !isfinite(y)
        if isinf(x) && isfinite(y)
            return Complex{T}(x, x > 0 ? (iszero(y) ? y : copysign(T(Inf), y)) : copysign(T(Inf), -y))
        elseif isfinite(x) && isinf(y)
            return Complex{T}(-T(Inf), y)
        else
            return Complex{T}(T(NaN), T(NaN))
        end
    elseif x > 7 || yabs > 7
        return _loggamma_stirling(z)
    elseif x < 0.1
        if iszero(x) && iszero(y)
            imagpart = signbit(x) ? copysign(T(π), -y) : -y
            return Complex{T}(T(Inf), imagpart)
        end
        return Complex(_logpi(T), copysign(2T(pi), y) * floor((one(T)/2) * x + one(T)/4)) -
            log(sinpi(z)) - _loggamma(Complex{T}(1 - x, -y))
    elseif abs(x - 1) + yabs < 0.1
        w = Complex{T}(x - one(T), y)
        return w * evalpoly(w, _taylor1(T))
    elseif abs(x - 2) + yabs < 0.1
        w = Complex{T}(x - 2, y)
        return w * evalpoly(w, _taylor2(T))
    else
        shiftprod = Complex{T}(x, yabs)
        xshift = x + one(T)
        sb = false
        signflips = 0
        while xshift ≤ 7
            shiftprod *= Complex{T}(xshift, yabs)
            sbp = signbit(imag(shiftprod))
            signflips += sbp & (sbp != sb)
            sb = sbp
            xshift += one(T)
        end
        shift = log(shiftprod)
        if signbit(y)
            shift = Complex(real(shift), signflips * -2T(pi) - imag(shift))
        else
            shift = Complex(real(shift), imag(shift) + signflips * 2T(pi))
        end
        return _loggamma_stirling(Complex{T}(xshift, y)) - shift
    end
end

####################################
## Complex{BigFloat} loggamma implementation
####################################
# Adapted from SpecialFunctions.jl (MIT license)
# Uses Stirling series with Bernoulli numbers computed via Akiyama-Tanigawa,
# reflection formula, upward recurrence, and branch correction via Float64 oracle.

# Scaled Stirling coefficients B_{2k}/(2k*(2k-1)) * zr^(1-2k) for k=0,...,n
# Bernoulli numbers computed inline via the Akiyama-Tanigawa algorithm
function _scaled_stirling_coeffs(n::Integer, zr::Complex{BigFloat})
    mmax = 2n
    A = Vector{Rational{BigInt}}(undef, mmax + 1)
    E = Vector{Complex{BigFloat}}(undef, n + 1)
    @inbounds for m = 0:mmax
        A[m+1] = 1 // (m + 1)
        for j = m:-1:1
            A[j] = j * (A[j] - A[j+1])
        end
        if iseven(m)
            k = m ÷ 2
            E[k+1] = A[1] / (2k * (2k - 1)) * zr^(1 - 2k)
        end
    end
    return E
end

function _loggamma_complex_bigfloat(z::Complex{BigFloat})
    bigpi = big(π)
    x = real(z)
    y = imag(z)

    if !isfinite(x) || !isfinite(y)
        inf = BigFloat(Inf)
        nan = BigFloat(NaN)
        if isinf(x) && isfinite(y)
            yim = x > 0 ? (iszero(y) ? y : copysign(inf, y)) : copysign(inf, -y)
            return Complex{BigFloat}(x, yim)
        elseif isfinite(x) && isinf(y)
            return Complex{BigFloat}(-inf, y)
        else
            return Complex{BigFloat}(nan, nan)
        end
    end

    # reflection formula
    if x < 0.5
        val = log(bigpi) - log(sinpi(z)) - _loggamma_complex_bigfloat(1 - z)
        return _loggamma_branchcorrect(val, z)
    end

    # upward recurrence: shift z into the Stirling region
    p = precision(BigFloat)
    r = max(0, Int(ceil(p - abs(z))))
    zr = z + r

    # Stirling series
    N = max(10, p ÷ 15)
    B = _scaled_stirling_coeffs(N, zr)
    lg = sum(B[2:end]) + (zr - big"0.5") * log(zr) - zr + log(sqrt(2 * bigpi))

    # undo upward shift via log of product
    if r > 0
        prodarg = prod(z + (i - 1) for i in 1:r)
        lg -= log(prodarg)
    end

    return _loggamma_branchcorrect(lg, z)
end

# Branch correction: offset by multiples of 2πi to match the Float64 branch
function _loggamma_branchcorrect(val::Complex{BigFloat}, z::Complex{BigFloat})
    zf = _loggamma_oracle64_point(z)
    val_f = _loggamma(zf)
    imv = imag(val)
    k = round(Int, (Float64(imv) - imag(val_f)) / (2π))
    return Complex{BigFloat}(real(val), imv - 2 * big(π) * k)
end

# Map a BigFloat complex point to Float64 for branch-cut determination
function _loggamma_oracle64_point(z::Complex{BigFloat})
    xr = Float64(real(z))
    xi = Float64(imag(z))
    n = round(Int, xr)
    if n ≤ 0 && isapprox(xr, Float64(n); atol=eps(Float64)) && abs(xi) ≤ 2eps(Float64)
        xr = real(z) > n ? nextfloat(xr) : prevfloat(xr)
    end
    return Complex{Float64}(xr, xi)
end

# Complex{BigFloat} entry point with guard precision
function _loggamma(z::Complex{BigFloat})
    imz = imag(z)
    rez = real(z)
    if iszero(imz)
        return Complex(loggamma(rez))
    end
    p0 = precision(BigFloat)
    guard = 16
    setprecision(p0 + guard) do
        zhi = Complex{BigFloat}(rez, imz)
        rhi = _loggamma_complex_bigfloat(zhi)
        setprecision(p0) do
            return Complex{BigFloat}(real(rhi), imag(rhi))
        end
    end
end

function _logabsgamma(x::BigFloat)
    if isnan(x)
        return x, 1
    elseif isinf(x)
        return x > 0 ? (x, 1) : (BigFloat(NaN), 1)
    elseif x > 0
        return real(_loggamma_complex_bigfloat(Complex{BigFloat}(x, zero(BigFloat)))), 1
    elseif iszero(x)
        return BigFloat(Inf), Int(sign(1 / x))
    end

    s = sinpi(x)
    iszero(s) && return BigFloat(Inf), 1
    return real(_loggamma_complex_bigfloat(Complex{BigFloat}(x, zero(BigFloat)))), (signbit(s) ? -1 : 1)
end

# Adapted from SpecialFunctions.jl, src/expint.jl, version 2.7.2, MIT License.

"""
    IncompleteGammaConvergenceError(algorithm, iterations)

The requested precision was not reached by an incomplete-gamma algorithm.
"""
struct IncompleteGammaConvergenceError <: Exception
    algorithm::Symbol
    iterations::Int
end

function Base.showerror(io::IO, err::IncompleteGammaConvergenceError)
    print(io, err.algorithm, " did not converge after ", err.iterations,
          " iterations at the requested precision")
end

####################################
## Public entry points
####################################

"""
    expint(z)
    expint(ν, z)

Compute the generalized exponential integral
`E_ν(z) = ∫₁^∞ exp(-z*t)/t^ν dt` on its principal branch.
"""
expint(ν::T, z::T) where {T<:AbstractFloat} = _expint(ν, z, false)
expint(ν::Complex{T}, z::Complex{T}) where {T<:AbstractFloat} =
    _expint(ν, z, false)
function expint(ν::Number, z::Number)
    ν, z = promote(float(ν), float(z))
    return _expint(ν, z, false)
end
expint(z::Number) = expint(one(z), z)

"""
    expintx(z)
    expintx(ν, z)

Compute the exponentially scaled generalized exponential integral
`exp(z) * E_ν(z)`.
"""
expintx(ν::T, z::T) where {T<:AbstractFloat} = _expint(ν, z, true)
expintx(ν::Complex{T}, z::Complex{T}) where {T<:AbstractFloat} =
    _expint(ν, z, true)
function expintx(ν::Number, z::Number)
    ν, z = promote(float(ν), float(z))
    return _expint(ν, z, true)
end
expintx(z::Number) = expintx(one(z), z)

####################################
## Evaluation dispatch
####################################

_expint(ν::Float16, z::Float16, expscaled::Bool) =
    Float16(_expint(Float32(ν), Float32(z), expscaled))
_expint(ν::ComplexF16, z::ComplexF16, expscaled::Bool) =
    ComplexF16(_expint(ComplexF32(ν), ComplexF32(z), expscaled))

function _expint(ν::T, z::T, expscaled::Bool) where {T<:AbstractFloat}
    if isnan(ν) || isnan(z)
        return oftype(z, NaN) * z
    elseif z < 0
        throw(DomainError(z,
            "expint has a complex value for negative z; pass complex(z)"))
    elseif iszero(z)
        return oftype(z, ν > 1 ? inv(ν - 1) : T(Inf))
    elseif iszero(ν)
        return expscaled ? inv(z) : exp(-z) / z
    end
    return _expint_unsafe(ν, z, expscaled)
end

function _expint(ν::Complex{T}, z::Complex{T},
                 expscaled::Bool) where {T<:AbstractFloat}
    if isnan(ν) || isnan(z)
        return oftype(z, NaN) * z
    elseif iszero(z)
        return oftype(z, real(ν) > 1 ? inv(ν - 1) : T(Inf))
    elseif iszero(ν)
        return expscaled ? inv(z) : exp(-z) / z
    end
    return _expint_unsafe(ν, z, expscaled)
end

function _expint_unsafe(ν::T, z::T,
                        expscaled::Bool) where {T<:AbstractFloat}
    if abs2(z) < 9
        positive_integer = isinteger(ν) && ν > 0
        if !positive_integer || ν <= typemax(Int)
            result = positive_integer ? _En_expand_origin_posint(ν, z) :
                                        _En_expand_origin_general(ν, z)
            return expscaled ? _En_safeexpmult(z, result) : result
        end
    end
    cf, _, _ = _En_cf_nogamma(ν, z)
    return expscaled ? cf : _En_safeexpmult(-z, cf)
end

function _expint_unsafe(ν::Complex{T}, z::Complex{T},
                        expscaled::Bool) where {T<:AbstractFloat}
    if abs2(z) < 9
        realν = real(ν)
        positive_integer = isreal(ν) && isinteger(realν) && realν > 0
        if !positive_integer || realν <= typemax(Int)
            result = positive_integer ? _En_expand_origin_posint(realν, z) :
                                        _En_expand_origin_general(ν, z)
            return expscaled ? _En_safeexpmult(z, result) : result
        end
    end
    if real(z) > 0
        cf, _, _ = _En_cf_nogamma(ν, z)
        return expscaled ? cf : _En_safeexpmult(-z, cf)
    end
    return _expint_left_halfplane(ν, z, expscaled)
end

####################################
## Shared numerical helpers
####################################

@inline function _En_converged(
    delta::T, first::T, second::T, tol
) where {T<:Real}
    return abs(delta) <= tol * max(abs(first), abs(second))
end

@inline function _En_converged(
    delta::Complex{T}, first::Complex{T}, second::Complex{T}, tol
) where {T<:AbstractFloat}
    delta2 = abs2(delta)
    scale2 = max(abs2(first), abs2(second))
    if isfinite(delta2) && !iszero(delta2) &&
       isfinite(scale2) && !iszero(scale2)
        return delta2 <= abs2(tol) * scale2
    end
    return abs(delta) <= tol * max(abs(first), abs(second))
end

function _En_safeexpmult(z::T, value::T) where {T<:Real}
    ez = exp(z)
    if isinf(ez) || iszero(ez)
        return sign(value) * exp(z + log(abs(value)))
    end
    return ez * value
end

function _En_safeexpmult(
    z::Complex{T}, value::Complex{T}
) where {T<:AbstractFloat}
    ez = exp(z)
    if isinf(ez) || iszero(ez)
        return exp(z + log(value))
    end
    return ez * value
end

####################################
## Continued fraction
####################################

# Gamma-free continued fraction for E_ν(z):
# https://functions.wolfram.com/GammaBetaErf/ExpIntegralE/10/0001/
function _En_cf_nogamma(
    ν::T, z::T; maxiter::Union{Nothing,Int}=nothing,
    throw_on_failure::Bool=true
) where {T}
    R = typeof(real(z))
    tol = 8 * eps(one(R))
    cap = isnothing(maxiter) ? 50_000 : maxiter
    B = z + ν
    Bprev::typeof(B) = z
    A::typeof(B) = one(B)
    Aprev::typeof(B) = one(B)
    previous = Aprev / Bprev
    stable = 0

    for i = 2:cap
        previous_coefficient = i - 1
        A, Aprev = z * A + previous_coefficient * Aprev, A
        B, Bprev = z * B + previous_coefficient * Bprev, B
        coefficient = ν + previous_coefficient
        A, Aprev = A + coefficient * Aprev, A
        B, Bprev = B + coefficient * Bprev, B

        scale = max(abs(A), abs(Aprev), abs(B), abs(Bprev))
        A /= scale
        Aprev /= scale
        B /= scale
        Bprev /= scale

        current = A / B
        if i > 4 && _En_converged(
            current - previous, current, previous, tol
        )
            stable += 1
            stable >= 2 && return current, i, true
        else
            stable = 0
        end
        previous = current
    end

    throw_on_failure &&
        throw(IncompleteGammaConvergenceError(:expint_continued_fraction, cap))
    return A / B, cap, false
end

####################################
## Origin expansions
####################################

function _En_expand_origin_posint(
    n, z::T; maxiter::Union{Nothing,Int}=nothing
) where {T<:AbstractFloat}
    m = n - 1
    gammaterm = if m < 100
        result = one(z)
        for k = 1:Int(m)
            result *= -z / k
        end
        result
    else
        sign = isodd(m) ? -one(m) : one(m)
        sign * exp(m * log(abs(z)) - loggamma(m + 1))
    end
    return _En_expand_origin_posint(n, z, gammaterm, maxiter)
end

function _En_expand_origin_posint(
    n, z::Complex{T}; maxiter::Union{Nothing,Int}=nothing
) where {T<:AbstractFloat}
    m = n - 1
    gammaterm = if m < 100
        result = one(z)
        for k = 1:Int(m)
            result *= -z / k
        end
        result
    else
        exp(m * log(-z) - loggamma(m + 1))
    end
    return _En_expand_origin_posint(n, z, gammaterm, maxiter)
end

function _En_expand_origin_posint(n, z::T, gammaterm::T,
                                  maxiter::Union{Nothing,Int}) where {T}
    frac = one(z)
    gammaterm *= digamma(oftype(real(z), n)) - log(z)
    sumterm = n == 1 ? zero(z) : frac / (1 - n)
    R = typeof(real(z))
    tol = 8 * eps(one(R))
    cap = isnothing(maxiter) ? 50_000 : maxiter
    stable = 0

    for k = 1:cap
        frac *= -z / k
        if k != n - 1
            term = frac / (k + 1 - n)
            sumterm += term
            if _En_converged(term, sumterm, one(sumterm), tol)
                stable += 1
                stable >= 2 && return gammaterm - sumterm
            else
                stable = 0
            end
        end
    end
    throw(IncompleteGammaConvergenceError(:expint_origin_series, cap))
end

function _En_expand_origin_general(
    ν::T, z::T; maxiter::Union{Nothing,Int}=nothing
) where {T}
    gammaterm = gamma(1 - ν) * z^(ν - 1)
    frac = one(z)
    sumterm = frac / (1 - ν)
    R = typeof(real(z))
    tol = 8 * eps(one(R))
    cap = isnothing(maxiter) ? 50_000 : maxiter
    stable = 0

    for k = 1:cap
        frac *= -z / k
        term = frac / (k + 1 - ν)
        sumterm += term
        if _En_converged(term, sumterm, one(sumterm), tol)
            stable += 1
            stable >= 2 && return gammaterm - sumterm
        else
            stable = 0
        end
    end
    throw(IncompleteGammaConvergenceError(:expint_origin_series, cap))
end

####################################
## Left-half-plane continuation
####################################

function _En_taylor(ν::T, start::T, z0::T, delta::T;
                    maxiter::Union{Nothing,Int}=nothing) where {T}
    a = exp(z0) * start
    total = a
    delta_prod_fact = -delta
    R = typeof(real(total))
    tol = 8 * eps(one(R))
    cap = isnothing(maxiter) ? max(32, 2 * precision(R)) : maxiter
    stable = 0

    for k = 0:cap
        a = (delta_prod_fact + a * delta * (ν - k - 1) / (k + 1)) / z0
        total += a
        if _En_converged(a, total, one(total), tol)
            stable += 1
            stable >= 2 && return exp(-z0) * total
        else
            stable = 0
        end
        delta_prod_fact *= -delta / (k + 2)
    end
    throw(IncompleteGammaConvergenceError(:expint_continuation_series, cap))
end

function _expint_left_halfplane(
    ν::Complex{T}, z::Complex{T}, expscaled
) where {T<:AbstractFloat}
    reflect = imag(z) < 0
    rez, imz = real(z), abs(imag(z))
    original_z = z
    z = reflect ? conj(z) : z
    ν = reflect ? conj(ν) : ν
    R = typeof(real(z))
    quick = max(64, 2 * precision(R))
    target = -log(8 * eps(one(R)))
    s = R(5) * target / (R(16) * sqrt(R(quick)))
    estimate = 2 * s * sqrt(s^2 - real(z))
    imstart = max(imz, estimate)
    z0 = complex(rez, imstart)
    cf, _, converged = _En_cf_nogamma(ν, z0; maxiter=quick,
                                      throw_on_failure=false)

    doublings = 0
    while !converged
        imstart *= 2
        z0 = complex(rez, imstart)
        cf, _, converged = _En_cf_nogamma(ν, z0; maxiter=quick,
                                          throw_on_failure=false)
        doublings += 1
        doublings > 4 * precision(R) + 64 &&
            throw(IncompleteGammaConvergenceError(:expint_left_halfplane, quick))
    end

    if imz > 0 && z0 == z
        result = expscaled ? cf : _En_safeexpmult(-z0, cf)
        return reflect ? conj(result) : result
    end

    start = _En_safeexpmult(-z0, cf)
    distance = imstart - imz
    nsteps = ceil(Int, 2 * distance)
    nsteps > 1_000_000 &&
        throw(IncompleteGammaConvergenceError(:expint_left_halfplane, nsteps))
    delta = (imz - imstart) * im / nsteps
    for _ = 1:nsteps
        start = _En_taylor(ν, start, z0, delta)
        z0 += delta
    end

    result = reflect ? conj(start) : start
    if iszero(imz)
        x = real(z)
        upper_lip = !signbit(imag(original_z))
        branchsign = upper_lip ? 1 : -1
        if isreal(ν)
            logabs, sign = logabsgamma(real(ν))
            jump_half = sign * oftype(x, π) *
                        exp((real(ν) - 1) * log(-x) - logabs)
            result = real(result) - branchsign * jump_half * im
        elseif !upper_lip
            branchjump = 2 * oftype(x, π) *
                         exp((ν - 1) * log(-x) - loggamma(ν)) * im
            result += branchjump
        end
    end
    return expscaled ? _En_safeexpmult(original_z, result) : result
end

using Gamma: IncompleteGammaConvergenceError

include("inc_gamma_mpmath_cases.jl")

_refmetric(got, ref) = iszero(ref) ? abs(got - ref) : abs((got - ref) / ref)

const _FLOAT64_LOWER_RTOL = Dict(
    "small-z" => 5e-14,
    "crossover" => 4e-14,
    "large-z" => 3e-14,
    "negative-a" => 4e-15,
    "complex-quadrants" => 5e-15,
    "negative-axis" => 8e-15,
    "complex-crossover" => 1.1e-14,
)

const _FLOAT64_UPPER_RTOL = Dict(
    "small-z" => 5e-16,
    "crossover" => 2e-12,
    "large-z" => 3e-14,
    "negative-a" => 4e-10,
    "complex-quadrants" => 5e-15,
    "negative-axis" => 8e-15,
    "complex-crossover" => 1.1e-14,
)

function _parse_float64_case(case)
    _, ar, ai, zr, zi, lr, li, ur, ui, regime = case
    a = complex(parse(Float64, ar), parse(Float64, ai))
    z = complex(parse(Float64, zr), parse(Float64, zi))
    lower = complex(Float64(parse(BigFloat, lr)), Float64(parse(BigFloat, li)))
    upper = complex(Float64(parse(BigFloat, ur)), Float64(parse(BigFloat, ui)))
    return a, z, lower, upper, regime
end

function _parse_bigfloat_case(case)
    _, ar, ai, zr, zi, lr, li, ur, ui, regime = case
    a = complex(parse(BigFloat, ar), parse(BigFloat, ai))
    z = complex(parse(BigFloat, zr), parse(BigFloat, zi))
    lower = complex(parse(BigFloat, lr), parse(BigFloat, li))
    upper = complex(parse(BigFloat, ur), parse(BigFloat, ui))
    return a, z, lower, upper, regime
end

@testset "incomplete gamma API" begin
    for T in (
        Float16, Float32, Float64, BigFloat,
        Complex{Float16}, Complex{Float32}, ComplexF64, Complex{BigFloat},
    )
        a, z = T(2), T(3)
        @test @inferred(gamma(a, z)) isa T
        @test @inferred(gamma_lower(a, z)) isa T
        p, q = @inferred Gamma.gamma_inc(a, z)
        @test p isa T
        @test q isa T
        @test p + q == one(T)
    end

    @test @inferred(gamma(2, 3)) isa Float64
    @test @inferred(gamma_lower(2, 3)) isa Float64
    @test @inferred(Gamma.gamma_inc(2, 3)) isa Tuple{Float64,Float64}
    @test @inferred(gamma(2, 3.0)) isa Float64
    @test @inferred(gamma_lower(2, 3.0)) isa Float64
    @test @inferred(Gamma.gamma_inc(2, 3.0)) isa Tuple{Float64,Float64}
    @test @inferred(gamma(Float32(2), 3.0)) isa Float64
    @test @inferred(gamma_lower(Float32(2), 3.0)) isa Float64
    @test @inferred(Gamma.gamma_inc(Float32(2), 3.0)) isa
          Tuple{Float64,Float64}
    @test @inferred(gamma(2, π)) isa Float64
    @test @inferred(gamma_lower(2, π)) isa Float64
    @test @inferred(Gamma.gamma_inc(2, π)) isa Tuple{Float64,Float64}
    @test @inferred(gamma(2 + 0im, 3.0)) isa ComplexF64
    @test @inferred(gamma_lower(2 + 0im, 3.0)) isa ComplexF64
    @test @inferred(Gamma.gamma_inc(2 + 0im, 3.0)) isa
          Tuple{ComplexF64,ComplexF64}
    @test @inferred(gamma(big"2", 3.0 + 0im)) isa Complex{BigFloat}
    @test @inferred(gamma_lower(big"2", 3.0 + 0im)) isa Complex{BigFloat}
    @test @inferred(Gamma.gamma_inc(big"2", 3.0 + 0im)) isa
          Tuple{Complex{BigFloat},Complex{BigFloat}}

    @test_throws MethodError Gamma.gamma_inc(2.0, 3.0, 0)
    @test_throws DomainError gamma_lower(0.0, 1.0)
    @test_throws DomainError gamma_lower(-1.0, 1.0)
    @test_throws DomainError gamma_lower(0.5, -1.0)
    @test_throws DomainError gamma(0.5, -1.0)
    @test_throws DomainError Gamma.gamma_inc(0.5, -1.0)
    @test_throws DomainError Gamma.gamma_inc(0.0, 1.0)
    for T in (ComplexF64, Complex{BigFloat})
        a, z = T(0), T(1)
        @test gamma(a, z) ≈ Gamma.expint(T(1), z)
        @test_throws DomainError gamma_lower(a, z)
        @test_throws DomainError Gamma.gamma_inc(a, z)
    end
    @test_throws IncompleteGammaConvergenceError Gamma._En_cf_nogamma(
        0.5, 2.0; maxiter=5
    )

    Gamma.gamma_inc(2.5, 2.0)
    Gamma.gamma_inc(2.5 + 0.2im, 2.0 + 0.1im)
    @test (@allocated Gamma.gamma_inc(2.5, 2.0)) == 0
    @test (@allocated Gamma.gamma_inc(2.5 + 0.2im, 2.0 + 0.1im)) == 0
end

@testset "Float16 evaluation through Float32" begin
    a, z = Float16(2.5), Float16(2)
    a32, z32 = Float32(a), Float32(z)
    @test gamma(a, z) === Float16(gamma(a32, z32))
    @test gamma_lower(a, z) === Float16(gamma_lower(a32, z32))
    p32, q32 = Gamma.gamma_inc(a32, z32)
    @test Gamma.gamma_inc(a, z) === (Float16(p32), Float16(q32))

    a, z = ComplexF16(0.5, 0.25), ComplexF16(2, 1)
    a32, z32 = ComplexF32(a), ComplexF32(z)
    @test gamma(a, z) === ComplexF16(gamma(a32, z32))
    @test gamma_lower(a, z) === ComplexF16(gamma_lower(a32, z32))
    p32, q32 = Gamma.gamma_inc(a32, z32)
    @test Gamma.gamma_inc(a, z) === (ComplexF16(p32), ComplexF16(q32))
    @test Gamma.gamma_inc(real(a), z) ===
          Gamma.gamma_inc(ComplexF16(real(a)), z)

    @test Gamma.gamma_inc(Float16(25), Float16(1000)) ===
          (Float16(1), Float16(0))
    @test Gamma.gamma_inc(Float16(300), Float16(300)) ===
          (Float16(0.508), Float16(0.4924))
end

@testset "closed forms and identities" begin
    for T in (Float64, ComplexF64)
        z = T(3)
        for n = 1:8
            upper_big, lower_big = setprecision(128) do
                zb = BigFloat(3)
                complete = BigFloat(factorial(n - 1))
                ub = complete * exp(-zb) *
                     sum(zb^k / factorial(k) for k = 0:n-1)
                ub, complete - ub
            end
            upper, lower = T(upper_big), T(lower_big)
            @test gamma(T(n), z) ≈ upper rtol=16eps(Float64)
            @test gamma_lower(T(n), z) ≈ lower rtol=16eps(Float64)
        end
    end

    for T in (Float64, BigFloat)
        a, z = T(1.75), T(0.8)
        lower = gamma_lower(a, z)
        upper = gamma(a, z)
        @test lower + upper ≈ gamma(a) rtol=128eps(T)
        @test gamma_lower(a + one(T), z) ≈
              a * lower - z^a * exp(-z) rtol=256eps(T)
    end

    a, z = 0.5, 1.25
    @test gamma_lower(a, z) ≈ sqrt(π) * SpecialFunctions.erf(sqrt(z))
    @test gamma(a, z) ≈ sqrt(π) * SpecialFunctions.erfc(sqrt(z))
    @test gamma(a, z) ≈ z^a * Gamma.expint(1 - a, z) rtol=32eps(Float64)
end

@testset "generalized exponential integral" begin
    for T in (
        Float16, Float32, Float64, BigFloat,
        Complex{Float16}, Complex{Float32}, ComplexF64, Complex{BigFloat},
    )
        ν, z = T(2), T(2)
        @test @inferred(Gamma.expint(ν, z)) isa T
        @test @inferred(Gamma.expintx(ν, z)) isa T
    end
    for f in (Gamma.expint, Gamma.expintx)
        ν, z = Float16(0.5), Float16(2)
        @test f(ν, z) === Float16(f(Float32(ν), Float32(z)))
        ν, z = ComplexF16(0.5, 0.25), ComplexF16(2, 1)
        @test f(ν, z) === ComplexF16(f(ComplexF32(ν), ComplexF32(z)))
        @test f(real(ν), z) === f(ComplexF16(real(ν)), z)
    end
    @test @inferred(Gamma.expint(1, 2.0)) isa Float64
    @test @inferred(Gamma.expintx(1, 2.0)) isa Float64
    @test @inferred(Gamma.expint(Float32(1), 2.0)) isa Float64
    @test @inferred(Gamma.expintx(Float32(1), 2.0)) isa Float64
    @test @inferred(Gamma.expint(1, π)) isa Float64
    @test @inferred(Gamma.expintx(1, π)) isa Float64
    @test @inferred(Gamma.expint(1 + 0im, 2.0)) isa ComplexF64
    @test @inferred(Gamma.expintx(1 + 0im, 2.0)) isa ComplexF64
    @test @inferred(Gamma.expint(big"1", 2.0 + 0im)) isa Complex{BigFloat}
    @test @inferred(Gamma.expintx(big"1", 2.0 + 0im)) isa Complex{BigFloat}

    setprecision(256) do
        cases = (
            (complex(big"0.5"), complex(big"2"),
             complex(big"0.05702612399289204827645887193117990741350550876172169370280621084224744842308610367344716230811960771")),
            (complex(big"1"), complex(big"1"),
             complex(big"0.21938393439552027367716377546012164903104729340690820757797861307356869855914154472221025103513725")),
            (complex(big"2.3"), complex(big"1", big"2"),
             complex(big"-0.08900094783292969603230068696548775791852855369872728695579144430812641514561403479949250371475292285",
                     big"-0.04708186526834273439842211340143026024172539176077138569967436983433323606340448808894006124274060858")),
            (complex(big"-0.5"), complex(big"-3", big"0.1"),
             complex(big"-5.279703637332678779535765471007746416904813944781438259335574021808117056613629975047922595892107188",
                     big"0.5748584955040566259508322825190196921611540523181709746994239790504698808465109404900441709276139088")),
        )
        for (ν, z, reference) in cases
            value = Gamma.expint(ν, z)
            @test _refmetric(value, reference) < big"1e-72"
            @test Gamma.expintx(ν, z) ≈ exp(z) * value rtol=big"1e-72"
        end
    end

    @test isnan(Gamma.expint(NaN, 1.0))
    @test isnan(Gamma.expint(1.0, NaN))
    @test isnan(Gamma.expint(complex(NaN), 1.0 + 0im))
    @test isnan(Gamma.expint(1.0 + 0im, complex(NaN)))
    @test_throws DomainError Gamma.expint(1.0, -1.0)
    @test Gamma.expint(2.0, 0.0) == 1.0
    @test isinf(Gamma.expint(1.0, 0.0))
    @test Gamma.expint(2.0 + 0im, 0.0 + 0im) == 1.0 + 0im
    @test isinf(real(Gamma.expint(1.0 + 0im, 0.0 + 0im)))
    @test Gamma.expint(0.0, 2.0) ≈ exp(-2) / 2
    @test Gamma.expintx(0.0, 2.0) == 0.5
    @test Gamma.expint(0.0 + 0im, 2.0 + 1im) ==
          exp(-(2.0 + 1im)) / (2.0 + 1im)
    @test Gamma.expintx(0.0 + 0im, 2.0 + 1im) == inv(2.0 + 1im)
    @test Gamma.expint(2.0) == Gamma.expint(1.0, 2.0)
    @test Gamma.expintx(2.0) == Gamma.expintx(1.0, 2.0)
    @test Gamma.expintx(0.5, 1e20) == 1e-20
    @test Gamma.expintx(1e20, 1e20) == 5e-21
    for T in (Float64, BigFloat)
        ν, z = parse(T, "1e20"), T(0.5)
        value = Gamma.expint(ν, z)
        @test isfinite(value) && value > 0
        @test Gamma.expint(complex(ν), complex(z)) == complex(value)
    end

    reference = sqrt(π / 4) * SpecialFunctions.erfc(2)
    @test Gamma.expint(0.5, 4.0) ≈ reference rtol=8eps()
    @test Gamma.expintx(0.5, 4.0) ≈ exp(4) * reference rtol=8eps()

    z = 0.5
    for n in (2, 101)
        @test n * Gamma.expint(n + 1, z) ≈
              exp(-z) - z * Gamma.expint(n, z) rtol=8eps()
    end

    branch_cases = (
        (1.0, complex(-3.0, 0.0),
         -9.933832570625416558 - 3.1415926535897932385im),
        (1.0, complex(-3.0, -0.0),
         -9.933832570625416558 + 3.1415926535897932385im),
        (0.5 + 0.25im, complex(-3.0, 0.0),
         -7.6931876545950181363 - 1.7637064918779949669im),
        (0.5 + 0.25im, complex(-3.0, -0.0),
         -9.258828300557080910 - 0.0037977027808670030im),
    )
    for (ν, zcut, expected) in branch_cases
        @test Gamma.expint(ν, zcut) ≈ expected rtol=8eps()
    end
end

@testset "incomplete gamma special values" begin
    @test gamma_lower(2.5, 0.0) == 0.0
    @test_throws DomainError gamma_lower(-0.5, 0.0)
    @test_throws DomainError Gamma.gamma_inc(BigFloat(0), BigFloat(1))
    @test_throws DomainError Gamma.gamma_inc(BigFloat(-0.5), BigFloat(0))
    @test_throws DomainError Gamma.gamma_inc(
        complex(big"-0.5", big"0.25"), complex(big"0")
    )
    @test gamma(2.5, 0.0) == gamma(2.5)
    @test gamma(2.5 + 0im, 0.0 + 0im) == gamma(2.5 + 0im)
    @test_throws DomainError gamma(0.0, 0.0)
    @test_throws DomainError gamma(0.0 + 0im, 0.0 + 0im)

    @test gamma(0.0, 1.0) ≈ Gamma.expint(1.0)
    @test gamma(-1.0, 1.0) ≈ exp(-1) - Gamma.expint(1.0)

    @test Gamma.gamma_inc(2.5, 0.0) == (0.0, 1.0)
    @test Gamma.gamma_inc(Inf, 0.0) == (0.0, 1.0)
    @test_throws DomainError Gamma.gamma_inc(-0.5, 0.0)
    @test Gamma.gamma_inc(2.5 + 0im, 0.0 + 0im) ==
          (0.0 + 0im, 1.0 + 0im)
    @test Gamma.gamma_inc(complex(Inf), complex(0.0)) ==
          (0.0 + 0im, 1.0 + 0im)
    @test_throws DomainError Gamma.gamma_inc(-0.5 + 0im, 0.0 + 0im)

    complex_p, complex_q = Gamma.gamma_inc(2.0 + 0im, 1.0 + 0im)
    real_p, real_q = Gamma.gamma_inc(2.0, 1.0)
    @test complex_p ≈ real_p
    @test complex_q ≈ real_q
    fallback_p, fallback_q = Gamma.gamma_inc(12.0 + 0im, 15.0 + 0im)
    @test fallback_p + fallback_q == 1.0 + 0im

    a, z = 0.5 + 0.2im, -4.0 + 1.0im
    p, q = Gamma.gamma_inc(a, z)
    complete = gamma(a)
    @test p + q ≈ 1
    @test p ≈ gamma_lower(a, z) / complete rtol=2e-14
    @test q ≈ gamma(a, z) / complete rtol=2e-14
end

@testset "incomplete gamma convergence reporting" begin
    @test Gamma.gamma_inc(1e19, 1.0) == (0.0, 1.0)

    _, iterations, converged = Gamma._En_cf_nogamma(
        0.5, 2.0; maxiter=2, throw_on_failure=false
    )
    @test iterations == 2
    @test !converged

    forced_failures = (
        (:expint_origin_series, 1,
         () -> Gamma._En_expand_origin_posint(2, 0.5; maxiter=1)),
        (:expint_origin_series, 1,
         () -> Gamma._En_expand_origin_general(0.5, 0.5; maxiter=1)),
        (:expint_continuation_series, 1,
         () -> Gamma._En_taylor(
             0.5 + 0im, Gamma.expint(0.5, 3 + 3im), 3.0 + 3.0im, 0.1im;
             maxiter=1
         )),
        (:lower_incomplete_gamma_series, 1,
         () -> Gamma._gamma_lower_series(0.5, 0.5; maxiter=1)),
        (:normalized_lower_incomplete_gamma_series, 1,
         () -> Gamma._gamma_lower_series_normalized(0.5, 0.5; maxiter=1)),
    )
    for (algorithm, iterations, f) in forced_failures
        err = try
            f()
            nothing
        catch caught
            caught
        end
        @test err isa IncompleteGammaConvergenceError
        @test err.algorithm == algorithm
        @test err.iterations == iterations
        @test sprint(showerror, err) ==
              "$algorithm did not converge after $iterations iterations at the requested precision"
    end

    err = try
        Gamma.expint(Float16(100), Complex{Float16}(-100, 1))
        nothing
    catch caught
        caught
    end
    @test err isa IncompleteGammaConvergenceError
    @test err.algorithm == :expint_continuation_series

    err = try
        Gamma._expint_left_halfplane(
            ComplexF16(1000), ComplexF16(-10, 1), false
        )
        nothing
    catch caught
        caught
    end
    @test err isa IncompleteGammaConvergenceError
    @test err.algorithm == :expint_left_halfplane
end

@testset "mpmath Float64 and ComplexF64 references" begin
    for case in INCOMPLETE_GAMMA_MPMATH_FLOAT64_CASES
        case[10] == "temme-gap" && continue
        a, z, lower_ref, upper_ref, regime = _parse_float64_case(case)
        lower, upper = gamma_lower(a, z), gamma(a, z)
        @test _refmetric(lower, lower_ref) <= _FLOAT64_LOWER_RTOL[regime]
        @test _refmetric(upper, upper_ref) <= _FLOAT64_UPPER_RTOL[regime]
    end
end

@testset "mpmath BigFloat and Complex{BigFloat} references" begin
    for bits in (256, 512)
        setprecision(bits) do
            tolerance = BigFloat(10)^6 * eps(BigFloat)
            for case in INCOMPLETE_GAMMA_MPMATH_CASES
                a, z, lower_ref, upper_ref, _ = _parse_bigfloat_case(case)
                @test _refmetric(gamma_lower(a, z), lower_ref) <= tolerance
                @test _refmetric(gamma(a, z), upper_ref) <= tolerance
            end
        end
    end
end

@testset "real mpmath references" begin
    float_cases = filter(c -> c[3] == "0" && c[5] == "0" &&
                             !startswith(c[4], "-") &&
                             c[10] != "temme-gap",
                         INCOMPLETE_GAMMA_MPMATH_FLOAT64_CASES)
    for case in float_cases
        _, ar, _, zr, _, lr, _, ur, _, regime = case
        a, z = parse(Float64, ar), parse(Float64, zr)
        lower_ref = Float64(parse(BigFloat, lr))
        upper_ref = Float64(parse(BigFloat, ur))
        @test _refmetric(gamma_lower(a, z), lower_ref) <=
              _FLOAT64_LOWER_RTOL[regime]
        @test _refmetric(gamma(a, z), upper_ref) <=
              _FLOAT64_UPPER_RTOL[regime]
    end

    big_cases = filter(c -> c[3] == "0" && c[5] == "0" &&
                           !startswith(c[4], "-") &&
                           c[10] != "temme-gap",
                       INCOMPLETE_GAMMA_MPMATH_CASES)
    for bits in (256, 512)
        setprecision(bits) do
            tolerance = BigFloat(10)^6 * eps(BigFloat)
            for case in big_cases
                _, ar, _, zr, _, lr, _, ur, _, _ = case
                a, z = parse(BigFloat, ar), parse(BigFloat, zr)
                lower_ref, upper_ref = parse(BigFloat, lr), parse(BigFloat, ur)
                @test _refmetric(gamma_lower(a, z), lower_ref) <= tolerance
                @test _refmetric(gamma(a, z), upper_ref) <= tolerance
            end
        end
    end
end

@testset "cross precision" begin
    selected = (
        ("0.5", "2.0"),
        ("5.0", "5.9"),
        ("100.0", "101.1"),
        ("-0.5001", "3.0"),
    )
    values256 = setprecision(256) do
        [(gamma_lower(parse(BigFloat, a), parse(BigFloat, z)),
          gamma(parse(BigFloat, a), parse(BigFloat, z))) for (a, z) in selected]
    end
    setprecision(512) do
        for ((a, z), (lower256, upper256)) in zip(selected, values256)
            lower512 = gamma_lower(parse(BigFloat, a), parse(BigFloat, z))
            upper512 = gamma(parse(BigFloat, a), parse(BigFloat, z))
            @test _refmetric(BigFloat(lower256), lower512) < big"1e-74"
            @test _refmetric(BigFloat(upper256), upper512) < big"1e-74"
        end
    end
end

@testset "SpecialFunctions comparison and small z" begin
    positive_real_cases = filter(
        c -> c[3] == "0" && c[5] == "0" &&
             parse(BigFloat, c[2]) > 0 && parse(BigFloat, c[4]) >= 0,
        INCOMPLETE_GAMMA_MPMATH_FLOAT64_CASES,
    )
    for case in positive_real_cases
        _, ar, _, zr, _, lr, _, ur, _, regime = case
        a, z = parse(Float64, ar), parse(Float64, zr)
        lower_big, upper_big = parse(BigFloat, lr), parse(BigFloat, ur)
        p_ref = lower_big / (lower_big + upper_big)
        q_ref = upper_big / (lower_big + upper_big)
        p, q = Gamma.gamma_inc(a, z)
        @test isfinite(p)
        @test isfinite(q)
        @test p + q == 1
        use_p = p_ref <= q_ref
        got, reference = use_p ? p : q, use_p ? p_ref : q_ref
        rounded = Float64(reference)
        if iszero(rounded) || abs(rounded) < floatmin(Float64)
            @test iszero(got)
        else
            @test abs(BigFloat(got) - reference) / abs(reference) <= 3e-12
        end
    end

    for (a, z) in (
        (1e-16, prevfloat(1.1)),
        (0.25, prevfloat(1.1)),
        (prevfloat(0.5), prevfloat(1.1)),
        (0.5, 1e-300),
        (prevfloat(1.0), 1e-300),
    )
        p, q = Gamma.gamma_inc(a, z)
        p_ref, q_ref = setprecision(512) do
            Gamma.gamma_inc(BigFloat(a), BigFloat(z))
        end
        use_p = abs(p_ref) <= abs(q_ref)
        got, reference = use_p ? p : q, use_p ? p_ref : q_ref
        @test _refmetric(BigFloat(got), reference) <= 384eps(Float64)
    end

    setprecision(256) do
        a, z = big"2.5", big"1e-100"
        p, q = Gamma.gamma_inc(a, z)
        sp, sq = SpecialFunctions.gamma_inc(a, z)
        @test p > 0
        @test sp == 0
        @test q == 1 - p
        @test sq == 1
    end
end

using Gamma
using Test
import SpecialFunctions
using Random
Random.seed!(1993)

# how many iters to run randomized tests for
const NUM_RUNS = 10000


@testset "gamma type inference and return type" begin
    @testset "T: $T" for T in (Float16, Float32, Float64, BigFloat,
              Complex{Float16}, Complex{Float32}, Complex{Float64}, Complex{BigFloat},
              Int32 , Int64, BigInt)
        @inferred gamma(one(T))
        @test gamma(one(T)) isa float(T)
    end
end

@testset "gamma(::$T)" for (T, max, rtol) in ((Float16, 13, 1.0), (Float32, 43, 1.0), (Float64, 170, 7))
    @inferred gamma(one(T))
    for _ in 1:NUM_RUNS
        x = rand(T)*max
        @test isapprox(T(SpecialFunctions.gamma(widen(x))), gamma(x), rtol=rtol*eps(T))
        if isinteger(x) && x != 0
            @test_throws DomainError gamma(-x)
        else
            @test isapprox(T(SpecialFunctions.gamma(widen(-x))), gamma(-x), atol=nextfloat(T(0.),2), rtol=rtol*eps(T))
        end
    end
    @test isnan(gamma(T(NaN)))
    @test isinf(gamma(T(Inf)))
    @test_throws DomainError isinf(gamma(-T(Inf)))
end

x = [0, 1, 2, 3, 8, 15, 20, 30]
@test SpecialFunctions.gamma.(x) ≈ gamma.(x)
@inferred gamma(1)

# gamma_near_1 exact at expansion point (constant term = Γ(1) = 1)
@test Gamma.gamma_near_1(1.0) === 1.0
# nearby values: degree-3 Taylor gives O((x-1)^4) error,
# ≲ 1e-4 for |x-1| ≤ 0.1
for x in (0.90, 0.95, 1.0, 1.05, 1.10)
    @test Gamma.gamma_near_1(x) ≈ gamma(x) atol=1e-3
end

include("test_loggamma.jl")
include("test_digamma.jl")
include("test_incomplete_gamma.jl")

module Gamma

    using LogExpFunctions: logmxp1

    include("gamma_implementation.jl")
    include("loggamma.jl")
    include("digamma.jl")
    include("expint.jl")
    include("incomplete_gamma.jl")
    include("precompile.jl")

    export gamma, gamma_lower, gamma_inc, expint, expintx,
           loggamma, logabsgamma, logfactorial, digamma

end

# Partly adapted from SpecialFunctions.jl (MIT license).

"""
    digamma(x)

Compute the digamma function of `x`, the logarithmic derivative of `gamma(x)`.

External links: [DLMF](https://dlmf.nist.gov/5.2#E2), [Wikipedia](https://en.wikipedia.org/wiki/Digamma_function)
"""
digamma(x::Union{Integer, Rational}) = digamma(float(x))
digamma(x::Float64) = _digamma(x)
digamma(x::Float32) = _digamma(x)
digamma(x::Float16) = Float16(_digamma(Float32(x)))
digamma(x::BigFloat) = _digamma(x)
digamma(z::Complex{Float64}) = _digamma(z)
digamma(z::Complex{Float32}) = _digamma(z)
digamma(z::Complex{Float16}) = Complex{Float16}(_digamma(Complex{Float32}(z)))
digamma(z::Complex{BigFloat}) = _digamma(z)
function digamma(z::Complex{<:Union{Integer, Rational}})
    zf = Complex(float.(reim(z))...)
    return digamma(zf)
end

_cotpi(x::Union{Float32, Float64, BigFloat}) = inv(tanpi(x))

function _cotpi(z::Complex{T}) where T<:Union{Float32, Float64, BigFloat}
    x, y = reim(z)
    iszero(y) && return Complex{T}(inv(tanpi(x)), -zero(T))
    e = exp(-2T(π) * abs(y))
    e2 = e * e
    sech = 2e / (one(T) + e2)
    tanh = (one(T) - e2) / (one(T) + e2)
    denom = one(T) - cospi(2x) * sech
    return Complex{T}(sinpi(2x) * sech / denom, -copysign(tanh, y) / denom)
end

# Float64 implementation
function _digamma(z::Union{Float64, Complex{Float64}})
    x = real(z)
    if x <= 0
        ψ = -π * _cotpi(z)
        z = 1 - z
        x = real(z)
    else
        ψ = zero(z)
    end
    X = 8
    if x < X
        n = X - floor(Int, x)
        for ν = 1:n-1
            ψ -= inv(z + ν)
        end
        ψ -= inv(z)
        z += n
    end
    t = inv(z)
    ψ += log(z) - 0.5 * t
    t *= t
    return ψ - t * evalpoly(t, (
        0.08333333333333333, -0.008333333333333333,
        0.003968253968253968, -0.004166666666666667,
        0.007575757575757576, -0.021092796092796094,
        0.08333333333333333, -0.4432598039215686
    ))
end

# Float32 implementation
function _digamma(z::Union{Float32, Complex{Float32}})
    x = real(z)
    if x <= 0f0
        ψ = -Float32(π) * _cotpi(z)
        z = one(z) - z
        x = real(z)
    else
        ψ = zero(z)
    end
    X = 8f0
    if x < X
        n = 8 - floor(Int, x)
        for ν = 1:n-1
            ψ -= inv(z + ν)
        end
        ψ -= inv(z)
        z += n
    end
    t = inv(z)
    ψ += log(z) - 0.5f0 * t
    t *= t
    return ψ - t * evalpoly(t, (
        0.083333336f0, -0.008333334f0,
        0.003968254f0, -0.004166667f0,
        0.007575758f0, -0.021092797f0
    ))
end

# BigFloat implementation
# Following MPFR, cache the integers B[2n] * (2n+1)! and absorb the
# factorial into the asymptotic recurrence.
const _BERNOULLI_SCALED = BigInt[
    1,
    -4,
    120,
    -12096,
    3024000,
    -1576143360,
    1525620096000,
    -2522591034163200,
    6686974460694528000,
    -27033456071346536448000,
    160078872315904478576640000,
    -1342964491649083924630732800000,
    15522270327163593186886877184000000,
    -241364461951740682229320388129587200000,
    4946702463524336786354770193822515200000000,
    -131259771031915242949184995422830881406976000000,
]
const _BERNOULLI_SCALED_LOCK = ReentrantLock()

function _isprime_odd(n::Int)
    d = 3
    while d*d <= n
        n % d == 0 && return false
        d += 2
    end
    return true
end

function _bernoulli_denominator(n::Int)
    den = BigInt(6)
    for p in 5:2:n+1
        n % (p - 1) == 0 && _isprime_odd(p) && (den *= p)
    end
    return den
end

function _scaled_bernoulli_candidate(n::Int, den::BigInt, p::Int)
    scale = BigInt(1) << p
    zeta = copy(scale)
    zeta += cld(scale, BigInt(1) << n)

    k = 3
    while true
        kn = BigInt(k)^n
        kn > scale && break
        zeta += scale ÷ kn
        k += 1
    end
    zeta += cld(scale, (n - 1) * BigInt(k)^(n - 1))

    setrounding(BigFloat, RoundNearest) do
        setprecision(p + 32) do
            x = BigFloat(zeta)
            x *= 2den * factorial(BigInt(n))
            x = ldexp(x, -p) / (2big(π))^n
            return round(BigInt, x)
        end
    end
end

function _scaled_bernoulli(n::Int, guard::Int=16)
    m = 2n
    den = _bernoulli_denominator(m)
    bits = 1 + ndigits(den; base=2) +
           loggamma(Float64(m + 1)) / log(2) - m * log2(2π)
    p = max(32, ceil(Int, bits) + guard)
    a = _scaled_bernoulli_candidate(m, den, p)
    b = _scaled_bernoulli_candidate(m, den, p + 32)
    while a != b
        p += 32
        a = b
        b = _scaled_bernoulli_candidate(m, den, p + 32)
    end
    b *= factorial(BigInt(m + 1)) ÷ den
    return isodd(n) ? b : -b
end

function _bernoulli_scaled(n::Int)
    lock(_BERNOULLI_SCALED_LOCK) do
        while length(_BERNOULLI_SCALED) < n
            push!(_BERNOULLI_SCALED, _scaled_bernoulli(length(_BERNOULLI_SCALED) + 1))
        end
        return _BERNOULLI_SCALED[n]
    end
end

function _digamma_asymptotic_big(z::BigFloat)
    psi = log(z) - inv(2z)
    w = inv(z * z)
    threshold = ldexp(one(BigFloat), -precision(BigFloat) - 8) *
                max(abs(psi), one(BigFloat))
    t = one(z)
    n = 1
    while true
        t *= w
        t /= 2n * (2n +1)
        term = t * _bernoulli_scaled(n) / 2n
        abs(term) <= threshold && break
        psi -= term
        n += 1
    end
    return psi
end

function _digamma_asymptotic_big(z::Complex{BigFloat})
    psi = log(z) - inv(2z)
    w = inv(z * z)
    threshold = ldexp(one(BigFloat), -precision(BigFloat) - 8) *
                max(abs(psi), one(BigFloat))
    t = one(z)
    n = 1
    while true
        t *= w
        t /= 2n * (2n + 1)
        term = t * _bernoulli_scaled(n) / 2n
        abs(term) <= threshold && break
        psi -= term
        n += 1
    end
    return psi
end

_digamma_cutoff_big() = max(2, (precision(BigFloat) + 3) ÷ 4)

function _digamma_positive_big(z::BigFloat)
    cutoff = _digamma_cutoff_big()
    s = zero(z)
    while z < cutoff
        s += inv(z)
        z += 1
    end
    return _digamma_asymptotic_big(z) - s
end

function _digamma_positive_big(z::Complex{BigFloat})
    cutoff = _digamma_cutoff_big()
    cutoff2 = BigFloat(cutoff)^2
    s = zero(z)
    while real(z) < cutoff && abs2(z) < cutoff2
        s += inv(z)
        z += 1
    end
    return _digamma_asymptotic_big(z) - s
end

function _digamma_big(z::Union{BigFloat, Complex{BigFloat}})
    if real(z) < big"0.5"
        return _digamma_positive_big(1 - z) - big(π) * _cotpi(z)
    else
        return _digamma_positive_big(z)
    end
end

function _digamma(x::BigFloat)
    isnan(x) && return x
    isinf(x) && return x > 0 ? x : BigFloat(NaN)
    iszero(x) && return copysign(BigFloat(Inf), -x)
    x < 0 && isinteger(x) && return BigFloat(NaN)

    p0 = precision(BigFloat)
    e = exponent(x)
    e <= -2 * max(precision(x), p0) && return -inv(x)
    x > 0 && p0 + 30 < e && return log(x)

    setprecision(p0 + max(16, ndigits(p0; base=2) + 8)) do
        xhi = BigFloat(x)
        yhi = _digamma_big(xhi)
        setprecision(p0) do
            return BigFloat(yhi)
        end
    end
end

function _digamma(z::Complex{BigFloat})
    x, y = reim(z)
    if isnan(x) || isnan(y)
        return Complex{BigFloat}(BigFloat(NaN), BigFloat(NaN))
    elseif isinf(x) || isinf(y)
        return log(z)
    elseif iszero(x) && iszero(y)
        return Complex{BigFloat}(_digamma(x), zero(BigFloat))
    end

    p0 = precision(BigFloat)
    setprecision(p0 + max(16, ndigits(p0; base=2) + 8)) do
        zhi = Complex{BigFloat}(x, y)
        yhi = _digamma_big(zhi)
        setprecision(p0) do
            return Complex{BigFloat}(real(yhi), imag(yhi))
        end
    end
end

####################################
## Public entry points
####################################

"""
    gamma(a, z)

Compute the unnormalised upper incomplete gamma function `Γ(a,z)`.
"""
gamma(a::T, z::T) where {T<:AbstractFloat} = _gamma(a, z)
gamma(a::Complex{T}, z::Complex{T}) where {T<:AbstractFloat} = _gamma(a, z)
function gamma(a::Number, z::Number)
    a, z = promote(float(a), float(z))
    return _gamma(a, z)
end

"""
    gamma_lower(a, z)

Compute the unnormalised lower incomplete gamma function `γ(a,z)`.
"""
gamma_lower(a::T, z::T) where {T<:AbstractFloat} = _gamma_lower(a, z)
gamma_lower(a::Complex{T}, z::Complex{T}) where {T<:AbstractFloat} =
    _gamma_lower(a, z)
function gamma_lower(a::Number, z::Number)
    a, z = promote(float(a), float(z))
    return _gamma_lower(a, z)
end

"""
    gamma_inc(a, z)

Return the regularised lower and upper incomplete gamma functions `(P, Q)`,
with `P + Q = 1`.
"""
gamma_inc(a::T, z::T) where {T<:AbstractFloat} = _gamma_inc(a, z)
gamma_inc(a::Complex{T}, z::Complex{T}) where {T<:AbstractFloat} =
    _gamma_inc(a, z)
function gamma_inc(a::Number, z::Number)
    a, z = promote(float(a), float(z))
    return _gamma_inc(a, z)
end

####################################
## Shared numerical methods
####################################

function _gamma_lower_series(a::T, z::T;
                             maxiter::Union{Nothing,Int}=nothing) where {T}
    R = typeof(real(z))
    tol = 8 * eps(one(R))
    cap = isnothing(maxiter) ? 50_000 : maxiter
    term = one(z) / a
    total = term
    stable = 0
    for n = 1:cap
        term *= z / (a + n)
        total += term
        if _En_converged(term, total, zero(total), tol)
            stable += 1
            stable >= 2 &&
                return _En_safeexpmult(a * log(z) - z, total)
        else
            stable = 0
        end
    end
    throw(IncompleteGammaConvergenceError(:lower_incomplete_gamma_series, cap))
end

function _gamma_upper_cf(a::T, z::T) where {T<:AbstractFloat}
    # Γ(a,z) = z^a E_{1-a}(z).
    ν = 1 - a
    scaled, _, _ = _En_cf_nogamma(ν, z)
    return _En_safeexpmult(a * log(z) - z, scaled)
end

function _gamma_upper_cf(
    a::Complex{T}, z::Complex{T}
) where {T<:AbstractFloat}
    ν = 1 - a
    scaled = if real(z) > 0
        _En_cf_nogamma(ν, z)[1]
    else
        _expint_left_halfplane(ν, z, true)
    end
    return _En_safeexpmult(a * log(z) - z, scaled)
end

function _gamma_lower_direct(a::T, z::T) where {T<:AbstractFloat}
    if a > 0 && z >= 0
        return z <= a + oftype(a, 0.1)
    end
    absa = abs(a)
    return abs(z) < absa + one(absa)
end

function _gamma_lower_direct(
    a::Complex{T}, z::Complex{T}
) where {T<:AbstractFloat}
    if isreal(a) && isreal(z) && real(a) > 0 && real(z) >= 0
        return real(z) <= real(a) + oftype(real(a), 0.1)
    end
    absa = abs(a)
    return abs(z) < absa + one(real(absa))
end

function _gamma_upper_unsafe(a::T, z::T) where {T}
    if _gamma_lower_direct(a, z)
        lower = _gamma_lower_series(a, z)
        return gamma(a) - lower
    end
    return _gamma_upper_cf(a, z)
end

function _gamma_lower_unsafe(a::T, z::T) where {T}
    if _gamma_lower_direct(a, z)
        return _gamma_lower_series(a, z)
    end
    complete = gamma(a)
    upper = _gamma_upper_cf(a, z)
    return complete - upper
end

####################################
## Upper incomplete gamma
####################################

_gamma(a::Float16, z::Float16) =
    Float16(_gamma(Float32(a), Float32(z)))
_gamma(a::ComplexF16, z::ComplexF16) =
    ComplexF16(_gamma(ComplexF32(a), ComplexF32(z)))

function _gamma(a::T, z::T) where {T<:AbstractFloat}
    z < 0 && !isinteger(a) &&
        throw(DomainError(
            z,
            "a negative real z has a complex principal value; pass complex(z)",
        ))
    if !(a > 0)
        iszero(z) && throw(DomainError(
            z, "the upper incomplete gamma is singular at z = 0"
        ))
        isinteger(a) && return _gamma_upper_cf(a, z)
    end
    return _gamma_upper_unsafe(a, z)
end

function _gamma(a::Complex{T}, z::Complex{T}) where {T<:AbstractFloat}
    if !(real(a) > 0)
        iszero(z) && throw(DomainError(
            z, "the upper incomplete gamma is singular at z = 0"
        ))
        isreal(a) && isinteger(real(a)) && return _gamma_upper_cf(a, z)
    end
    return _gamma_upper_unsafe(a, z)
end

function _gamma(a::BigFloat, z::BigFloat)
    z < 0 && !isinteger(a) &&
        throw(DomainError(
            z,
            "a negative real z has a complex principal value; pass complex(z)",
    ))
    if !(a > 0)
        iszero(z) && throw(DomainError(
            z, "the upper incomplete gamma is singular at z = 0"
        ))
        isinteger(a) && return _gamma_upper_cf(a, z)
    end
    p = precision(BigFloat)
    guard = max(24, ndigits(p; base=2) + 12)
    return setprecision(p + guard) do
        value = _gamma_upper_unsafe(BigFloat(a), BigFloat(z))
        setprecision(p) do
            BigFloat(value)
        end
    end
end

function _gamma(a::Complex{BigFloat}, z::Complex{BigFloat})
    if !(real(a) > 0)
        iszero(z) && throw(DomainError(
            z, "the upper incomplete gamma is singular at z = 0"
        ))
        isreal(a) && isinteger(real(a)) && return _gamma_upper_cf(a, z)
    end
    p = precision(BigFloat)
    guard = max(24, ndigits(p; base=2) + 12)
    return setprecision(p + guard) do
        ahi = Complex{BigFloat}(BigFloat(real(a)), BigFloat(imag(a)))
        zhi = Complex{BigFloat}(BigFloat(real(z)), BigFloat(imag(z)))
        value = _gamma_upper_unsafe(ahi, zhi)
        setprecision(p) do
            Complex{BigFloat}(BigFloat(real(value)), BigFloat(imag(value)))
        end
    end
end

####################################
## Lower incomplete gamma
####################################

_gamma_lower(a::Float16, z::Float16) =
    Float16(_gamma_lower(Float32(a), Float32(z)))
_gamma_lower(a::ComplexF16, z::ComplexF16) =
    ComplexF16(_gamma_lower(ComplexF32(a), ComplexF32(z)))

function _gamma_lower(a::T, z::T) where {T<:AbstractFloat}
    z < 0 && !isinteger(a) &&
        throw(DomainError(
            z,
            "a negative real z has a complex principal value; pass complex(z)",
        ))
    if !(a > 0)
        isinteger(a) &&
            throw(DomainError(a, "the lower incomplete gamma has a pole at a"))
        iszero(z) && throw(DomainError(
            z, "the lower incomplete gamma is singular at z = 0"
        ))
    end
    return _gamma_lower_unsafe(a, z)
end

function _gamma_lower(a::Complex{T}, z::Complex{T}) where {T<:AbstractFloat}
    if !(real(a) > 0)
        if isreal(a) && isinteger(real(a))
            throw(DomainError(a, "the lower incomplete gamma has a pole at a"))
        end
        iszero(z) && throw(DomainError(
            z, "the lower incomplete gamma is singular at z = 0"
        ))
    end
    return _gamma_lower_unsafe(a, z)
end

function _gamma_lower(a::BigFloat, z::BigFloat)
    z < 0 && !isinteger(a) &&
        throw(DomainError(
            z,
            "a negative real z has a complex principal value; pass complex(z)",
        ))
    if !(a > 0)
        isinteger(a) &&
            throw(DomainError(a, "the lower incomplete gamma has a pole at a"))
        iszero(z) && throw(DomainError(
            z, "the lower incomplete gamma is singular at z = 0"
        ))
    end
    p = precision(BigFloat)
    guard = max(24, ndigits(p; base=2) + 12)
    return setprecision(p + guard) do
        value = _gamma_lower_unsafe(BigFloat(a), BigFloat(z))
        setprecision(p) do
            BigFloat(value)
        end
    end
end

function _gamma_lower(a::Complex{BigFloat}, z::Complex{BigFloat})
    if !(real(a) > 0)
        if isreal(a) && isinteger(real(a))
            throw(DomainError(a, "the lower incomplete gamma has a pole at a"))
        end
        iszero(z) && throw(DomainError(
            z, "the lower incomplete gamma is singular at z = 0"
        ))
    end
    p = precision(BigFloat)
    guard = max(24, ndigits(p; base=2) + 12)
    return setprecision(p + guard) do
        ahi = Complex{BigFloat}(BigFloat(real(a)), BigFloat(imag(a)))
        zhi = Complex{BigFloat}(BigFloat(real(z)), BigFloat(imag(z)))
        value = _gamma_lower_unsafe(ahi, zhi)
        setprecision(p) do
            Complex{BigFloat}(BigFloat(real(value)), BigFloat(imag(value)))
        end
    end
end

####################################
## Regularised incomplete gamma
####################################

Base.@noinline function _ig_transition_exponent(a::T, z::T) where {T}
    ratio = z / a
    return a * log(a) - a + a * (Base.@inline logmxp1(ratio))
end

function _ig_exponent(a::T, z::T) where {T<:AbstractFloat}
    if a >= oftype(a, 50) && z > 0
        if oftype(a, 0.75) * a <= z <= oftype(a, 1.25) * a
            z == a && return a * log(a) - a
            return _ig_transition_exponent(a, z)
        end
    end
    return a * log(z) - z
end

# Adapted from SpecialFunctions.jl 2.8.0 (MIT license).
function _gamma_inc_taylor_x(a::Float64, x::Float64)
    l = 3.0
    c = x
    total = x / (a + 3.0)
    tol = 15e-15 / (a + 1.0)
    while true
        l += 1.0
        c *= -x / l
        term = c / (a + l)
        total += term
        abs(term) <= tol && break
    end

    correction =
        a * x * ((total / 6.0 - 0.5 / (a + 2.0)) * x + 1.0 / (a + 1.0))
    exponent = a * log(x)

    h = if a < 0.1
        top = evalpoly(a, (
            0.577215664901533, -0.409078193005776, -0.230975380857675,
            0.0597275330452234, 0.007669681649490,
            -0.00514889771323592, 0.000589597428611429,
        ))
        bottom = evalpoly(a, (
            1.0, 0.427569613095214, 0.158451672430138,
            0.0261132021441447, 0.00423244297896961,
        ))
        a * top / bottom
    else
        inv(gamma(a + 1.0)) - 1.0
    end
    inverse_gamma = 1.0 + h

    if (x < 0.25 && exponent > -0.13394) || a < x / 2.59
        power_minus_one = expm1(exponent)
        power = 1.0 + power_minus_one
        q = max(
            (power * correction - power_minus_one) * inverse_gamma - h,
            0.0,
        )
        return 1.0 - q, q
    end

    p = exp(exponent) * inverse_gamma * (1.0 - correction)
    return p, 1.0 - p
end

function _gamma_lower_series_normalized(
    a::T, z::T; maxiter::Union{Nothing,Int}=nothing
) where {T}
    iszero(z) && return zero(z)
    R = typeof(real(z))
    tol = 8 * eps(one(R))
    cap = isnothing(maxiter) ? 50_000 : maxiter
    term = one(z)
    total = term
    stable = 0
    for n = 1:cap
        term *= z / (a + n)
        total += term
        if _En_converged(term, total, zero(total), tol)
            stable += 1
            if stable >= 2
                exponent = a * log(z) - z
                gamma_argument = a + one(a)
                return _gamma_lower_series_normalized_result(
                    exponent, gamma_argument, total
                )
            end
        else
            stable = 0
        end
    end
    throw(IncompleteGammaConvergenceError(
        :normalized_lower_incomplete_gamma_series, cap
    ))
end

function _gamma_lower_series_normalized_result(
    exponent::T, gamma_argument::T, total::T
) where {T<:AbstractFloat}
    logabs, sign = logabsgamma(gamma_argument)
    return sign * _En_safeexpmult(exponent - logabs, total)
end

function _gamma_lower_series_normalized_result(
    exponent::Complex{T}, gamma_argument::Complex{T}, total::Complex{T}
) where {T<:AbstractFloat}
    if isreal(gamma_argument)
        logabs, sign = logabsgamma(real(gamma_argument))
        return sign * _En_safeexpmult(exponent - logabs, total)
    end
    return _En_safeexpmult(exponent - loggamma(gamma_argument), total)
end

function _gamma_inc_unsafe(a::Float64, z::Float64)
    if 0 < a < 1 && 0 < z < 1.1
        return _gamma_inc_taylor_x(a, z)
    end
    if _gamma_lower_direct(a, z)
        p = _gamma_lower_series_normalized(a, z)
        return p, one(p) - p
    end
    ν = 1 - a
    scaled, _, _ = _En_cf_nogamma(ν, z)
    exponent = _ig_exponent(a, z)
    return _gamma_inc_from_upper(a, scaled, exponent)
end

function _gamma_inc_unsafe(a::T, z::T) where {T<:AbstractFloat}
    if _gamma_lower_direct(a, z)
        p = _gamma_lower_series_normalized(a, z)
        return p, one(p) - p
    end
    ν = 1 - a
    scaled, _, _ = _En_cf_nogamma(ν, z)
    exponent = _ig_exponent(a, z)
    return _gamma_inc_from_upper(a, scaled, exponent)
end

function _gamma_inc_unsafe(
    a::Complex{T}, z::Complex{T}
) where {T<:AbstractFloat}
    if _gamma_lower_direct(a, z)
        p = _gamma_lower_series_normalized(a, z)
        return p, one(p) - p
    end
    ν = 1 - a
    scaled = if real(z) > 0
        _En_cf_nogamma(ν, z)[1]
    else
        _expint_left_halfplane(ν, z, true)
    end
    exponent = a * log(z) - z
    return _gamma_inc_from_upper(a, scaled, exponent)
end

function _gamma_inc_from_upper(a::Float64, scaled::Float64,
                               exponent::Float64)
    if 0 < a <= 11.5
        denominator = gamma(a)
        numerator = exp(exponent)
        q = numerator * scaled / denominator
        return one(q) - q, q
    end
    logabs, sign = logabsgamma(a)
    q = sign * _En_safeexpmult(exponent - logabs, scaled)
    return one(q) - q, q
end

function _gamma_inc_from_upper(a::T, scaled::T,
                               exponent::T) where {T<:AbstractFloat}
    logabs, sign = logabsgamma(a)
    q = sign * _En_safeexpmult(exponent - logabs, scaled)
    return one(q) - q, q
end

function _gamma_inc_from_upper(a::ComplexF64, scaled::ComplexF64,
                               exponent::ComplexF64)
    if isreal(a) && 0 < real(a) <= 11.5
        denominator = gamma(real(a))
        numerator = exp(exponent)
        if isfinite(numerator) && !iszero(numerator)
            q = numerator * scaled / denominator
            isfinite(q) && !iszero(q) && return one(q) - q, q
        end
    end
    q = if isreal(a)
        logabs, sign = logabsgamma(real(a))
        sign * _En_safeexpmult(exponent - logabs, scaled)
    else
        _En_safeexpmult(exponent - loggamma(a), scaled)
    end
    return one(q) - q, q
end

function _gamma_inc_from_upper(
    a::Complex{T}, scaled::Complex{T}, exponent::Complex{T}
) where {T<:AbstractFloat}
    q = if isreal(a)
        logabs, sign = logabsgamma(real(a))
        sign * _En_safeexpmult(exponent - logabs, scaled)
    else
        _En_safeexpmult(exponent - loggamma(a), scaled)
    end
    return one(q) - q, q
end

function _gamma_inc(a::Float16, z::Float16)
    p, q = _gamma_inc(Float32(a), Float32(z))
    return Float16(p), Float16(q)
end

function _gamma_inc(a::ComplexF16, z::ComplexF16)
    p, q = _gamma_inc(ComplexF32(a), ComplexF32(z))
    return ComplexF16(p), ComplexF16(q)
end

function _gamma_inc(a::T, z::T) where {T<:AbstractFloat}
    z < 0 && !isinteger(a) &&
        throw(DomainError(
            z,
            "a negative real z has a complex principal value; pass complex(z)",
        ))
    if !(a > 0)
        isinteger(a) &&
            throw(DomainError(a, "the lower incomplete gamma has a pole at a"))
        iszero(z) && throw(DomainError(
            z, "the upper incomplete gamma is singular at z = 0"
        ))
    end
    return _gamma_inc_unsafe(a, z)
end

function _gamma_inc(a::Complex{T}, z::Complex{T}) where {T<:AbstractFloat}
    if !(real(a) > 0)
        if isreal(a) && isinteger(real(a))
            throw(DomainError(a, "the lower incomplete gamma has a pole at a"))
        end
        iszero(z) && throw(DomainError(
            z, "the upper incomplete gamma is singular at z = 0"
        ))
    end
    return _gamma_inc_unsafe(a, z)
end

function _gamma_inc(a::BigFloat, z::BigFloat)
    z < 0 && !isinteger(a) &&
        throw(DomainError(
            z,
            "a negative real z has a complex principal value; pass complex(z)",
        ))
    if !(a > 0)
        isinteger(a) &&
            throw(DomainError(a, "the lower incomplete gamma has a pole at a"))
        iszero(z) && throw(DomainError(
            z, "the upper incomplete gamma is singular at z = 0"
        ))
    end
    p = precision(BigFloat)
    guard = max(24, ndigits(p; base=2) + 12)
    return setprecision(p + guard) do
        lower, upper = _gamma_inc_unsafe(BigFloat(a), BigFloat(z))
        setprecision(p) do
            BigFloat(lower), BigFloat(upper)
        end
    end
end

function _gamma_inc(a::Complex{BigFloat}, z::Complex{BigFloat})
    if !(real(a) > 0)
        if isreal(a) && isinteger(real(a))
            throw(DomainError(a, "the lower incomplete gamma has a pole at a"))
        end
        iszero(z) && throw(DomainError(
            z, "the upper incomplete gamma is singular at z = 0"
        ))
    end
    p = precision(BigFloat)
    guard = max(24, ndigits(p; base=2) + 12)
    return setprecision(p + guard) do
        ahi = Complex{BigFloat}(BigFloat(real(a)), BigFloat(imag(a)))
        zhi = Complex{BigFloat}(BigFloat(real(z)), BigFloat(imag(z)))
        lower, upper = _gamma_inc_unsafe(ahi, zhi)
        setprecision(p) do
            (
                Complex{BigFloat}(
                    BigFloat(real(lower)), BigFloat(imag(lower))
                ),
                Complex{BigFloat}(
                    BigFloat(real(upper)), BigFloat(imag(upper))
                ),
            )
        end
    end
end

using Gamma: digamma
const γ = Base.MathConstants.eulergamma
include("digamma_mpmath_cases.jl")

function _digamma_real_reference(x::T) where T<:AbstractFloat
    return T(SpecialFunctions.digamma(Float64(x)))
end

function _digamma_region_values(::Type{T}, maxval, seed) where T<:AbstractFloat
    rng = MersenneTwister(seed)
    values = T[]
    append!(values, T[0.0, -0.0, 0.5, 1, 2, 8, -0.5, -1.1, -2.5])

    tiny_lo = T === Float16 ? -3 : -12
    for _ in 1:40
        push!(values, T(10.0 ^ (tiny_lo * rand(rng))))
        push!(values, T(rand(rng)) * T(8) + eps(T))
        push!(values, T(rand(rng)) * T(maxval) + one(T))
    end

    for _ in 1:80
        x = T(rand(rng)) * T(maxval)
        isinteger(x) || push!(values, -x)
    end

    for n in 0:30
        δ = T((rand(rng) < 0.5 ? -1 : 1) * (1e-3 + 0.2rand(rng)))
        iszero(δ) || push!(values, -T(n) + δ)
    end

    return values
end

function _digamma_complex_region_values(::Type{T}, maxval, seed) where T<:AbstractFloat
    rng = MersenneTwister(seed)
    values = Complex{T}[]
    append!(values, Complex{T}[
        complex(T(0), T(1//8)),
        complex(T(1//2), T(1//8)),
        complex(T(1), T(1)),
        complex(T(7), T(3)),
        complex(T(-1//2), T(1//8)),
        complex(T(-2), T(1//4)),
        complex(T(maxval), T(2)),
    ])

    for _ in 1:50
        push!(values, complex((T(2) * T(rand(rng)) - one(T)) * T(3),
                              (T(2) * T(rand(rng)) - one(T)) * T(3)))
        push!(values, complex((T(2) * T(rand(rng)) - one(T)) * T(maxval),
                              (T(2) * T(rand(rng)) - one(T)) * T(maxval / 4)))
    end

    for n in 0:20
        δx = T((rand(rng) < 0.5 ? -1 : 1) * (1e-3 + 0.1rand(rng)))
        δy = T((rand(rng) < 0.5 ? -1 : 1) * (1e-3 + 0.1rand(rng)))
        push!(values, complex(-T(n) + δx, δy))
    end

    filter!(z -> !iszero(imag(z)), values)
    return values
end

function _finite_sf_digamma(z::Complex)
    ref = SpecialFunctions.digamma(ComplexF64(z))
    return all(isfinite, reim(ref)) ? ref : nothing
end

@testset "digamma type inference and return type" begin
    @testset "T: $T" for T in (Float16, Float32, Float64,
              Complex{Float16}, Complex{Float32}, Complex{Float64},
              BigFloat, Complex{BigFloat}, Int32, Int64)
        @inferred digamma(one(T))
        @test digamma(one(T)) isa float(T)
    end
end

@testset "digamma SpecialFunctions cases" begin
    for T in (Float32, Float64)
        @test digamma(T(9)) ≈ T(2.140641477955609996536345)
        @test digamma(T(2.5)) ≈ T(0.7031566406452431872257)
        @test digamma(T(0.1)) ≈ T(-10.42375494041107679516822)
        @test digamma(T(7e-4)) ≈ T(-1429.147493371120205005198)
        @test digamma(T(7e-5)) ≈ T(-14286.29138623969227538398)
        @test digamma(T(7e-6)) ≈ T(-142857.7200612932791081972)
        @test digamma(T(2e-6)) ≈ T(-500000.5772123750382073831)
        @test digamma(T(1e-6)) ≈ T(-1000000.577214019968668068)
        @test digamma(T(7e-7)) ≈ T(-1428572.005785942019703646)
        @test digamma(T(-0.5)) ≈ T(0.03648997397857652055902367)
        @test digamma(T(-1.1)) ≈ T(10.15416395914385769902271)
        @test digamma(T(0)) == T(-Inf)
        @test digamma(T(-1)) == T(-Inf)

        @test digamma(T(1/2)) ≈ T(-γ - log(4))
        @test digamma(T(1)) ≈ T(-γ)
        @test digamma(T(2)) ≈ T(1 - γ)
        @test digamma(T(3)) ≈ T(3/2 - γ)
        @test digamma(T(4)) ≈ T(11/6 - γ)
        @test digamma(T(5)) ≈ T(25/12 - γ)
        @test digamma(T(10)) ≈ T(7129/2520 - γ)
    end
end

@testset "digamma complex cases" begin
    for x in -10.2:0.3456:50
        @test digamma(x + 0im) ≈ digamma(x)
    end
    @test digamma(7 + 0im) ≈ 1.872784335098467139393487909917597568957840664060076401194232
    @test digamma(7im) ≈ 1.94761433458434866917623737015561385331974500663251349960124 +
                         1.642224898223468048051567761191050945700191089100087841536im
    @test digamma(-3.2 + 0.1im) ≈ 4.65022505497781398615943030397508454861261537905047116427511 +
                                  2.32676364843128349629415011622322040021960602904363963042380im
    @test digamma(ComplexF32(7, 0)) ≈ ComplexF32(digamma(7 + 0im))
    @test digamma(ComplexF32(0, 7)) ≈ ComplexF32(digamma(7im))
end

@testset "digamma seeded accuracy" begin
    for (T, maxval, scale) in ((Float16, 13, 2.0), (Float32, 43, 4.0), (Float64, 170, 4.0))
        @testset "real $T" begin
            for x in _digamma_region_values(T, maxval, 5000 + sizeof(T))
                isinteger(x) && x < 0 && continue
                ref = _digamma_real_reference(x)
                @test isapprox(digamma(x), ref; atol=scale*eps(T), rtol=scale*eps(T))
            end
        end
    end

    for (T, maxval, scale) in ((Float16, 13, 4.0), (Float32, 43, 64.0), (Float64, 170, 64.0))
        @testset "complex $T" begin
            for z in _digamma_complex_region_values(T, maxval, 6000 + sizeof(T))
                ref64 = _finite_sf_digamma(z)
                ref64 === nothing && continue
                ref = Complex{T}(ref64)
                @test isapprox(digamma(z), ref; atol=scale*eps(T), rtol=scale*eps(T))
            end
        end
    end

    setprecision(256) do
        @testset "real BigFloat" begin
            for x in BigFloat.(_digamma_region_values(Float64, 170, 7000))
                isinteger(x) && x < 0 && continue
                @test isapprox(digamma(x), SpecialFunctions.digamma(x); rtol=8eps(BigFloat))
            end
        end

        @testset "Complex{BigFloat} mpmath" begin
            tol = big"1e-58"
            for (xr, xi, yr, yi) in DIGAMMA_COMPLEX_BIGFLOAT_MPMATH_CASES
                z = Complex{BigFloat}(BigFloat(xr), BigFloat(xi))
                ref = Complex{BigFloat}(BigFloat(yr), BigFloat(yi))
                @test isapprox(digamma(z), ref; atol=tol, rtol=tol)
            end
        end
    end
end

@testset "BigFloat digamma" begin
    for p in (128, 256, 512)
        setprecision(p) do
            mpfr_tol = 10eps(BigFloat)
            for x in BigFloat.(["0.1", "0.5", "1.0", "2.5", "9.0", "50.0", "-0.5", "-1.1"])
                @test isapprox(digamma(x), SpecialFunctions.digamma(x); rtol=mpfr_tol)
            end
            @test digamma(big"0.0") == big"-Inf"
            @test digamma(BigFloat(-0.0)) == big"Inf"
            @test isnan(digamma(big"-1.0"))

            for x in (BigFloat(0.0), BigFloat(-0.0)), y in (BigFloat(0.0), BigFloat(-0.0))
                expected = Complex{BigFloat}(digamma(x), BigFloat(0.0))
                @test isequal(digamma(Complex{BigFloat}(x, y)), expected)
            end

            quoted_tol = max(big"1e-57", mpfr_tol)
            @test isapprox(digamma(Complex{BigFloat}(big"7.0", big"0.0")),
                big"1.872784335098467139393487909917597568957840664060076401194232";
                rtol=quoted_tol)
            @test isapprox(digamma(Complex{BigFloat}(big"0.0", big"7.0")),
                big"1.94761433458434866917623737015561385331974500663251349960124" +
                big"1.642224898223468048051567761191050945700191089100087841536" * im;
                rtol=quoted_tol)
            @test isapprox(digamma(Complex{BigFloat}(big"-3.2", big"0.1")),
                big"4.65022505497781398615943030397508454861261537905047116427511" +
                big"2.32676364843128349629415011622322040021960602904363963042380" * im;
                rtol=quoted_tol)

            z = Complex{BigFloat}(big"1.4", big"3.7")
            @test ComplexF64(digamma(z)) ≈ digamma(ComplexF64(z))

            identity_tol = 10eps(BigFloat)
            for z in (
                Complex{BigFloat}(big"1.3", big"0.7"),
                Complex{BigFloat}(big"7.0", big"3.0"),
                Complex{BigFloat}(big"-2.4", big"0.2"),
                Complex{BigFloat}(big"0.2", big"5.0"),
                Complex{BigFloat}(big"-6.7", big"-1.3"),
            )
                @test isapprox(digamma(z + 1), digamma(z) + inv(z); rtol=identity_tol)
                @test isapprox(digamma(conj(z)), conj(digamma(z)); rtol=identity_tol)
                @test isapprox(digamma(1 - z) - digamma(z), big(π) * cospi(z) / sinpi(z);
                               rtol=identity_tol)
                @test ComplexF64(digamma(z)) ≈ digamma(ComplexF64(z))
            end

            derivative_tol = 2cbrt(eps(BigFloat)^2)
            for z in (
                Complex{BigFloat}(big"1.3", big"0.7"),
                Complex{BigFloat}(big"3.5", big"-1.2"),
                Complex{BigFloat}(big"0.8", big"4.0"),
            )
                h = exp2(-precision(BigFloat) ÷ 3)
                dloggamma = (loggamma(z + h) - loggamma(z - h)) / (2h)
                @test isapprox(digamma(z), dloggamma; rtol=derivative_tol)
            end
        end
    end

    @testset "nonfinite Complex{BigFloat}" begin
        nan = BigFloat(NaN)
        inf = BigFloat(Inf)
        for z in (
            Complex{BigFloat}(nan, 0),
            Complex{BigFloat}(0, nan),
            Complex{BigFloat}(nan, inf),
        )
            @test all(isnan, reim(digamma(z)))
        end

        for z in (
            Complex{BigFloat}(inf, 1),
            Complex{BigFloat}(-inf, 1),
            Complex{BigFloat}(1, inf),
            Complex{BigFloat}(1, -inf),
        )
            @test isequal(digamma(z), log(z))
        end
    end
end

@testset "high precision digamma" begin
    setprecision(2048) do
        x = big"1.25"
        @test isapprox(digamma(x), SpecialFunctions.digamma(x); rtol=10eps(BigFloat))

        z = Complex{BigFloat}(big"1.3", big"0.7")
        @test isapprox(digamma(z + 1), digamma(z) + inv(z); rtol=10eps(BigFloat))
    end
end

@testset "scaled Bernoulli precision retry" begin
    expected = big"4439271675277203871382284388240112245696102400000000"
    @test Gamma._scaled_bernoulli(17, 0) == expected
end

@testset "digamma against SpecialFunctions" begin
    for (T, max, scale) in ((Float16, 13, 2.0), (Float32, 43, 64.0), (Float64, 170, 8.0))
        for _ in 1:NUM_RUNS
            x = rand(T) * max
            @test isapprox(digamma(x), T(SpecialFunctions.digamma(Float64(x)));
                           atol=scale*eps(T), rtol=scale*eps(T))
            xn = -x
            isinteger(xn) && continue
            @test isapprox(digamma(xn), T(SpecialFunctions.digamma(Float64(xn)));
                           atol=scale*eps(T), rtol=scale*eps(T))
        end
    end

    for (T, max, rtol) in ((Float32, 43, 64.0), (Float64, 170, 64.0))
        for _ in 1:NUM_RUNS
            z = Complex{T}(rand(T) * 2T(max) - T(max), rand(T) * 2T(max) - T(max))
            abs(imag(z)) < sqrt(eps(T)) && continue
            ref = Complex{T}(SpecialFunctions.digamma(ComplexF64(z)))
            all(isfinite, reim(ref)) || continue
            @test isapprox(digamma(z), ref; atol=rtol*eps(T), rtol=rtol*eps(T))
        end
    end
end

# Float64 version adapted from Cephes Mathematical Library (MIT license https://en.smath.com/view/CephesMathLibrary/license) by Stephen L. Moshier
# Copied from Bessels.jl (MIT license https://github.com/JuliaMath/Bessels.jl/)
"""
    gamma(x::T) where T <: Union{Float16, Float32, Float64}

Returns the gamma function, ``Γ(x)``, for real `x`.

```math
\\Gamma(x) = \\int_x^\\infty e^{-t} t^{x-1} dt \\,
```

External links: [DLMF](https://dlmf.nist.gov/5.2.1), [Wikipedia](https://en.wikipedia.org/wiki/Gamma_function)
"""
function gamma(_x::Float64)
    x = _x
    if x < 0 || !isfinite(x)
        isinteger(x) && throw(DomainError(_x, "NaN result for non-NaN input."))
        if !isfinite(x)
            x == -Inf && throw(DomainError(_x, "NaN result for non-NaN input."))
            return x
        end
        s = sinpi(x)
        x = -x # Use this rather than the traditional x = 1-x to avoid roundoff.
        s *= x
    end
    if x > 11.5
        w = inv(x)
        coefs = (1.0, 
            8.333333333333331800504e-2, 3.472222222230075327854e-3, -2.681327161876304418288e-3, -2.294719747873185405699e-4,
            7.840334842744753003862e-4, 6.989332260623193171870e-5, -5.950237554056330156018e-4, -2.363848809501759061727e-5,
            7.147391378143610789273e-4
        )
        w = evalpoly(w, coefs)
        # avoid overflow
        v = x ^ muladd(0.5, x, -0.25)
        res = sqrt(2pi) * v * (v / exp(x)) * w

        if _x < 0
            return π / (res * s)
        else
            return res
        end
    end
    P = (
        1.000000000000000000009e0, 8.378004301573126728826e-1, 3.629515436640239168939e-1, 1.113062816019361559013e-1,
        2.385363243461108252554e-2, 4.092666828394035500949e-3, 4.542931960608009155600e-4, 4.212760487471622013093e-5
    )
    Q = (
        9.999999999999999999908e-1, 4.150160950588455434583e-1, -2.243510905670329164562e-1, -4.633887671244534213831e-2,
        2.773706565840072979165e-2, -7.955933682494738320586e-4, -1.237799246653152231188e-3, 2.346584059160635244282e-4,
        -1.397148517476170440917e-5
    )

    z = 1.0
    while x >= 3.0
        x -= 1.0
        z *= x
    end
    while x < 2.0
        z /= x
        x += 1.0
    end

    x -= 2.0
    p = evalpoly(x, P)
    q = evalpoly(x, Q)
    return _x < 0 ? π * q / (s * z * p) : z * p / q
end

function gamma(_x::Float32)
    x = Float64(_x)
    if x < 0 || !isfinite(x)
        isinteger(x) && throw(DomainError(_x, "NaN result for non-NaN input."))
        if !isfinite(x)
            x == -Inf32 && throw(DomainError(_x, "NaN result for non-NaN input."))
            return _x
        end
        s = sinpi(x)
        x = 1 - x
    end
    if x < 5
        z = 1.0
        while x > 1
            x -= 1
            z *= x
        end
        num = evalpoly(x, (1.0, 0.41702538904450015, 0.24081703455575904, 0.04071509011391178, 0.015839573267537377))
        den = x*evalpoly(x, (1.0, 0.9942411061082665, -0.17434932941689474, -0.13577921102050783, 0.03028452206514555))
        res = z * num / den
    else
        x -= 1
        w = evalpoly(inv(x), (2.506628299028453, 0.20888413086840676, 0.008736513049552962, -0.007022997182153692, 0.0006787969600290756))
        res = @fastmath sqrt(x) * exp(muladd(log(x), x, -x)) * w
    end
    return Float32(_x < 0 ? π / (s * res) : res)
end

function gamma(_x::Float16)
    x = Float32(_x)
    if x < 0 || !isfinite(x)
        isinteger(x) && throw(DomainError(_x, "NaN result for non-NaN input."))
        if !isfinite(x)
            x == -Inf && throw(DomainError(_x, "NaN result for non-NaN input."))
            return _x
        end
        s = sinpi(x)
        x = 1 - x
    end
    x > 14 && return Float16(ifelse(_x > 0, Inf32, 0f0))
    z = 1f0
    while x > 1
        x -= 1
        z *= x
    end
    num = evalpoly(x, (1.0f0, 0.4170254f0, 0.24081704f0, 0.04071509f0, 0.015839573f0))
    den = x*evalpoly(x, (1.0f0, 0.9942411f0, -0.17434932f0, -0.13577922f0, 0.030284522f0))
    return Float16(_x < 0 ? Float32(π)*den / (s*z*num) : z * num / den)
end

function gamma(n::Integer)
    n < 0 && throw(DomainError(n, "`n` must not be negative."))
    FT = float(typeof(n))
    n == 0 && return FT(Inf)
    n > 20 && return gamma(float(n))
    @inbounds return FT(factorial(n-1))
end
gamma(n::BigInt) = BigFloat(factorial(n-1))

gamma_near_1(x) = evalpoly(x-one(x), (1.0, -0.5772156649015329, 0.9890559953279725, -0.23263776388631713))

function gamma(x::BigFloat)
    if x < 0 || !isfinite(x)
        isinteger(x) && throw(DomainError(x, "NaN result for non-NaN input."))
        if !isfinite(x)
            x == -Inf && throw(DomainError(x, "NaN result for non-NaN input."))
            return x
        end
    end
    p = precision(BigFloat)
    guard = max(32, ndigits(p; base=2) + 16)
    return setprecision(p + guard) do
        xhi = BigFloat(x)
        y, sign = logabsgamma(xhi)
        setprecision(p) do
            BigFloat(sign * exp(y))
        end
    end
end
gamma(x::Complex) = iszero(imag(x)) ? complex(gamma(real(x))) : exp(loggamma(x))

function gamma(x::Complex{BigFloat})
    iszero(imag(x)) && return complex(gamma(real(x)))
    p = precision(BigFloat)
    guard = max(32, ndigits(p; base=2) + 16)
    return setprecision(p + guard) do
        xhi = Complex{BigFloat}(BigFloat(real(x)), BigFloat(imag(x)))
        value = exp(loggamma(xhi))
        setprecision(p) do
            Complex{BigFloat}(BigFloat(real(value)), BigFloat(imag(value)))
        end
    end
end
